#line 65 "/home/dodo/SFP/fxform-1.2/src/w_custom.u"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "template.h"
#include "parse.h"


#line 250 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 12 "w_custom.c"


tpl_t *p_custom(parser_t *P)
{
  char *object_type="";
  int last_id_emitted= 0;
  tpl_t *T= tpl_new(
"\n"
"@form_constructor\n"
"\n"
"  $object_type *$G_obj;\n"
"  $G_obj= $def($objid)($objid =) $constructor\n"
"\n"
"@form_members\n"
"\n"
"  $def($objid)($object_type *$objid;)\n"
"\n"
"@form_widget_declarations\n"
" $def($objid)(void* $objid;)\n"
"\n"
"@form_widget_export\n"
"  $def($objid)(\n"
"     ifo->$objid= ffo->$objid;\n"
"  )\n"
"\n"
"@form_selector_ids\n"
"   $G_selector,\n"
"\n"

  );
     parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 
    if (!strcmp(kw,"objid")) {        char * K= parse_ident(P);
       tpl_replace(T,"$objid",K); continue; }

    if (!strcmp(kw,"object_type")) {  object_type= parse_cpp(P);  continue; }

    if (!strcmp(kw,"constructor")) {  tpl_replace_tpl(T,"$constructor", tpl_new(parse_cpp(P)));  continue; }


  if (!strcmp(kw,"signal")) {  
    char *sel= parse_ident(P);
    char *code= parse_cpp(P); 
    tpl_t *signal_tpl= tpl_new(
"\n"
"@form_signal_mappings\n"
"  FXMAPFUNC($sel, $form_class::$G_selector, $form_class::$G_method),\n"
"\n"
"@form_members\n"
"\n"
"long $G_method (FXObject *object,FXSelector sel, void *arg);\n"
"\n"
"@form_methods\n"
"\n"
"long $form_class::$G_method\n"
"    (FXObject *object,FXSelector sel, void *arg)\n"
"       { $code return 1; }\n"

    );
    tpl_replace(signal_tpl, "$sel", sel);
    tpl_replace(signal_tpl, "$code", code);
    tpl_append(T, signal_tpl);
  continue; }


 if (!strcmp(kw,"ext_signal")) { 
   char *id= parse_ident(P);
   char *code= parse_cpp(P); 
   tpl_t *signal_tpl= tpl_new(
"\n"
"@form_signal_mappings\n"
"  FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector + $object_type::$id,\n"
"                $form_class::$method),\n"
"\n"
"@form_members\n"
"\n"
"long $method(FXObject *object,FXSelector sel, void *arg);\n"
"\n"
"@form_methods\n"
"\n"
"long $form_class::$method (FXObject *object,FXSelector sel, void *arg)\n"
"       { $code return 1; }\n"

   );
   tpl_replace(signal_tpl,"$id", id);
   tpl_replace(signal_tpl,"$code", code);
   tpl_replace(signal_tpl,"$dummy",gen_symbol()); 
   tpl_replace(signal_tpl,"$method",gen_symbol()); 
   if (!last_id_emitted) {
     tpl_t *last_id= tpl_new(
         "@form_selector_ids\n"
         "$last= $G_selector+$object_type::ID_LASTMESSAGE,\n\n");
     tpl_replace(last_id,"$last", gen_symbol());
     tpl_append(signal_tpl, last_id);
     last_id_emitted= 1;
   }
   tpl_append(T, signal_tpl);
  continue; }
;

      p_error(P,0, "unknown keyword %s.\n",kw);
  }
 

  tpl_replace(T, "$object_type", object_type);
  tpl_builtin(T);
  return T;
}

#line 257 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 74 "/home/dodo/SFP/fxform-1.2/src/w_custom.u"


