#line 170 "/home/dodo/SFP/fxform-1.2/src/w_dialog.u"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "template.h"
#include "parse.h"

#line 10 "w_dialog.c"
static tpl_t *dialog_code();
static char *p_mainwindow_decorations(parser_t *P);
#line 181 "/home/dodo/SFP/fxform-1.2/src/w_dialog.u"

#line 250 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 16 "w_dialog.c"


tpl_t *p_dialog(parser_t *P)
{
   tpl_t *T= dialog_code();
   tpl_t *child;
      parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 
     if (!strcmp(kw,"decorations")) {  tpl_replace(T,"$decorations",
                              p_mainwindow_decorations(P));  continue; }

     if (!strcmp(kw,"pad_left")) {    tpl_replace_i(T, "$pad_left", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_right")) {    tpl_replace_i(T, "$pad_right", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_top")) {    tpl_replace_i(T, "$pad_top", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_bottom")) {    tpl_replace_i(T, "$pad_bottom", parse_int(P));
  continue; }
 if (!strcmp(kw,"vt_spacing")) {    tpl_replace_i(T, "$vt_spacing", parse_int(P));
  continue; }
if (!strcmp(kw,"hz_spacing")) {    tpl_replace_i(T, "$hz_spacing", parse_int(P));
  continue; }
 if (!strcmp(kw,"objid")) {        char * K= parse_ident(P);
       tpl_replace(T,"$objid",K); continue; }

     if (!strcmp(kw,"title")) {        char *  K= parse_strlit(P);
        tpl_replace(T,"$title",K); continue; }

     if (!strcmp(kw,"pos_x")) {        int  K= parse_int(P);
        tpl_replace_i(T,"$pos_x", K);  continue; }

     if (!strcmp(kw,"pos_y")) {        int  K= parse_int(P);
        tpl_replace_i(T,"$pos_y", K);  continue; }

     if (!strcmp(kw,"default_width")) {        int  K= parse_int(P);
        tpl_replace_i(T,"$default_width", K);  continue; }

     if (!strcmp(kw,"default_height")) {        int  K= parse_int(P);
        tpl_replace_i(T,"$default_height", K);  continue; }

     if (!strcmp(kw,"close")) {  tpl_replace(T,"$close_code", parse_cpp(P));  continue; }

     if ((child=parse_sub_widget(P,kw))) 
     {
        tpl_replace(child, "$container", "this");
        tpl_relocations(T, child);
        continue;
     }
       p_error(P,0, "unknown keyword %s.\n",kw);
  }
 
   tpl_replace(T, "$form_class", gen_symbol());
   tpl_builtin(T);

   return T;
}

#line 257 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 187 "/home/dodo/SFP/fxform-1.2/src/w_dialog.u"
static tpl_t *dialog_code()
{
   tpl_t *T= tpl_new(
#line 84 "w_dialog.c"
"\n"
"@top_level_interface\n"
"\n"
"typedef struct gui_$T($objid) gui_$T($objid)_t;\n"
"\n"
"typedef struct {\n"
"   int (*execute)(gui_$T($objid)_t *);\n"
"   void (*close)(gui_$T($objid)_t *);\n"
"} $G_dialog_class_t;\n"
"\n"
"struct gui_$T($objid) {\n"
"  $G_dialog_class_t *cls;\n"
"  void *self;\n"
"  <form_widget_declarations>\n"
"};\n"
"\n"
"#ifdef __cplusplus\n"
"extern \042C\042 {\n"
"#endif\n"
"\n"
"gui_$T($objid)_t *gui_c_$objid(void *owner);\n"
"\n"
"#ifdef __cplusplus\n"
"}\n"
"#endif\n"
"\n"
"@form_types\n"
"\n"
" class $form_class: public FXTopWindow\n"
" {\n"
"  FXDECLARE($form_class)\n"
" public:\n"
"  enum { ID_FIRST= FXTopWindow::ID_LAST,\n"
"         ID_SELF,\n"
"         <form_selector_ids> };\n"
"  <form_members>\n"
"  $form_class(FXWindow* own,const FXString& name,\n"
"         FXIcon *ic,FXIcon *mi,FXuint opts,\n"
"         FXint x,FXint y,FXint w,FXint h,\n"
"         FXint pl,FXint pr,FXint pt,FXint pb,\n"
"         FXint hs,FXint vs);\n"
"  virtual ~$form_class();\n"
"  $form_class() : FXTopWindow() { }\n"
"  void dialog_done(int value);\n"
"  long handle_close(FXObject *object,FXSelector sel, void *arg);\n"
" };\n"
"\n"
" FXDEFMAP($form_class) $G_map []= {\n"
"  FXMAPFUNC(SEL_CLOSE, $form_class::ID_SELF, $form_class::handle_close),\n"
"  <form_signal_mappings>\n"
" }; \n"
"\n"
" FXIMPLEMENT($form_class, FXTopWindow, $G_map, ARRAYNUMBER($G_map))\n"
" \n"
" // FIXME: the argument names must be changed so that\n"
" // we can have widgets called \047y\047 etc.\n"
" $form_class::$form_class(\n"
"         FXWindow* $G_own,const FXString& $G_name,\n"
"         FXIcon *$G_ic,FXIcon *$G_mi,FXuint $G_opts,\n"
"         FXint $G_x,FXint $G_y,FXint $G_w,FXint $G_h,\n"
"         FXint $G_pl,FXint $G_pr,FXint $G_pt,FXint $G_pb,\n"
"         FXint $G_hs,FXint $G_vs) :\n"
"               FXTopWindow($G_own,$G_name, $G_ic,$G_mi,$G_opts,\n"
"                            $G_x,$G_y,$G_w,$G_h,\n"
"                            $G_pl,$G_pr,$G_pt,$G_pb,\n"
"                            $G_hs,$G_vs)\n"
" {\n"
"   setTarget(this);\n"
"   setSelector(ID_SELF);\n"
"   <form_constructor>\n"
" }\n"
" $form_class:: ~ $form_class() { }\n"
" long $form_class::handle_close\n"
"    (FXObject *object,FXSelector sel, void *arg)\n"
" {\n"
"    $dev($close_code)(/* window closing code would go here */)\n"
"    return 0;\n"
" } \n"
" void $form_class::dialog_done(int value)\n"
" {\n"
"   FXApp::instance()->stopModal(value);\n"
" }\n"
" <form_methods>\n"
"\n"
"\n"
"@top_level_code \n"
"\n"
" gui_$T($objid)_t *gui_c_$objid(void *owner)\n"
" {\n"
"    // ffo -> fox form object\n"
"    // ifo -> interface form object \n"
"   $form_class *ffo;\n"
"   gui_$T($objid)_t * ifo;\n"
"   ffo= new $form_class(\n"
"       (FXWindow*) owner,\n"
"       $dev($title)(\042Dialog\042),\n"
"       NULL, NULL, // FIXME: icons\n"
"       $dev($decorations)(DECOR_ALL) ,\n"
"       $dev($pos_x)(0), $dev($pos_y)(0),\n"
"       $dev($default_width)(400), $dev($default_height)(400),\n"
"       $dev($pad_left)(0), $dev($pad_right)(0),\n"
"       $dev($pad_top)(0), $dev($pad_bottom)(0),\n"
"       $dev($hz_spacing)(0), $dev($vt_spacing)(0));\n"
"\n"
"   ifo= (typeof(ifo)) malloc(sizeof(*ifo));\n"
"   ifo->self= ffo;\n"
"   ifo->cls= ($G_dialog_class_t*) &gui_dialog_class;\n"
"\n"
"   <form_widget_export>\n"
"\n"
"   return ifo;\n"
" }\n"
"\n"

#line 193 "/home/dodo/SFP/fxform-1.2/src/w_dialog.u"
   );
   static int lib_done=0;
   if (!lib_done) {
     tpl_append(T, tpl_new(
#line 203 "w_dialog.c"
"\n"
"@library_code\n"
"\n"
"typedef struct {\n"
"   int (*execute)(void*);\n"
"   void (*close)(void*);\n"
"} gui_generic_dialog_class_t;\n"
"\n"
"typedef struct {\n"
"  void *cls;\n"
"  void *widget;\n"
"} gui_ptrpair_t;\n"
"\n"
"static int dialog_execute(void *form)\n"
"{\n"
"  gui_ptrpair_t *W= (gui_ptrpair_t*) form;\n"
"  FXTopWindow *win= (FXTopWindow*) W->widget;\n"
"  win->create();\n"
"  win->show(PLACEMENT_SCREEN);\n"
"  FXApp::instance()->refresh();\n"
"  return FXApp::instance()->runModalFor(win);\n"
"}\n"
"\n"
"static void dialog_close(void *form)\n"
"{\n"
"  gui_ptrpair_t *W= (gui_ptrpair_t*) form;\n"
"  FXTopWindow *win= (FXTopWindow*) W->widget;\n"
"  FXApp::instance()->stopModal(0);\n"
"  delete win;\n"
"  free(form);\n"
"}\n"
"\n"
"static gui_generic_dialog_class_t gui_dialog_class= {\n"
"   dialog_execute,\n"
"   dialog_close\n"
"};\n"
"\n"

#line 200 "/home/dodo/SFP/fxform-1.2/src/w_dialog.u"
     ));
     lib_done= 1;
   }
   return T;
}

#line 57 "/home/dodo/SFP/fxform-1.2/src/w_common.u"

static char *p_mainwindow_decorations(parser_t *P)
{
    char *dkw;
    static char *names[]= {
    "title", "minimize", "maximize",
    "close", "border", "shrinkable",
    "stretchable", "menu",0 };
    int decs[8];
    int i;
    for(i=0;i<8;i++) decs[i]= 0;
    parse_lcurly(P);
    while((dkw=parse_ident_or_rcurly(P)))
    {
         char *namepart; int R;
         if (!strncmp(dkw,"no_",3)) { namepart= dkw+3; R= 0; }
         else { namepart= dkw; R= 1; }
         for(i=0;names[i];i++)
           if (!strcmp(namepart,names[i])) { decs[i] = R; break; }
         if (!names[i]) {
            if (!strcmp(namepart,"resize"))
               decs[5]= decs[6]= R;
            else if (!strcmp(dkw,"all"))
               for(i=0;names[i];i++) decs[i]= 1;
            else if (!strcmp(dkw,"none"))
               for(i=0;names[i];i++) decs[i]= 0;
            else p_error(P,0,"unknown decoration %s.\n", dkw);
         }
    }

   char buf[1000];
   strcpy(buf," 0 ");
   for(i=0;names[i];i++)
     if (decs[i]) { 
      strcat(buf, " | DECOR_");
      strcat(buf, names[i]);
     }
   for(i=0;buf[i];i++) buf[i]= toupper(buf[i]);
   return strdup(buf);
}

#line 211 "/home/dodo/SFP/fxform-1.2/src/w_dialog.u"

#line 184 "/home/dodo/SFP/fxform-1.2/src/w_dialog.u"


