#line 113 "/home/dodo/SFP/fxform-1.2/src/w_float_spinner.u"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "template.h"
#include "parse.h"


#line 250 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 12 "w_float_spinner.c"


tpl_t *p_float_spinner(parser_t *P)
{
  tpl_t *T= tpl_new(
"\n"
"@form_constructor\n"
"\n"
"  FXRealSpinner *$G_obj;\n"
"\n"
"  $G_obj= $def($objid)($objid =)\n"
"    new FXRealSpinner($container, $dev($ncols)(3),\n"
"       // target and selector\n"
"       NULL, 0,\n"
"        $dev($layout_x)(LAYOUT_LEFT) |\n"
"        $dev($layout_y)(LAYOUT_TOP) |\n"
"        $dev($layout_side)(LAYOUT_SIDE_TOP) |\n"
"        $dev($layout_fill_x)(0) |\n"
"        $dev($layout_fill_y)(0) |\n"
"        $dev($frame)(0) |\n"
"\n"
"        $nef($max)(REALSPIN_NOMAX |)\n"
"        $nef($min)(REALSPIN_NOMIN |)\n"
"       // there are some options, but I dont know how to use those yet.\n"
"        SPIN_NORMAL,\n"
"\n"
"        0,0,0,0, // x,y,w,h\n"
"        $dev($pad_left)(DEFAULT_PAD),\n"
"        $dev($pad_right)(DEFAULT_PAD),\n"
"        $dev($pad_top)(DEFAULT_PAD),\n"
"        $dev($pad_bottom)(DEFAULT_PAD));\n"
"\n"
"    $def($max $min)(\n"
"      $G_obj->setRange($dev($min)(0.0), $dev($max)(1.0));\n"
"    )\n"
"    $def($increment)(\n"
"      $G_obj->setIncrement($increment);\n"
"    )\n"
"\n"
"  $def($font_size $font_family)(\n"
"     FXFontDesc $G_font_desc;\n"
"     $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"  )\n"
"\n"
"  $def($font_size)(\n"
"     $G_font_desc.size= $font_size * 10;\n"
"  )\n"
"\n"
"  $def($font_family)(\n"
"     strcpy($G_font_desc.face, $font_family);\n"
"  )\n"
"\n"
"  $def($font_size $font_family)(\n"
"    $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"    $G_obj->setFont($G_font);\n"
"    @library_code  static FXFont *$G_font;\n"
"    @GUI_object_creation  // $G_font->create(); \n"
"    @form_constructor\n"
"  )\n"
"\n"
"\n"
"@form_members\n"
"\n"
"  $def($objid)(FXRealSpinner *$objid;)\n"
"\n"
"@form_widget_declarations $def($objid)(gui_float_spinner_t $objid;)\n"
"\n"
"@form_widget_export $def($objid)(ifo->$objid.widget= ffo->$objid;\n"
" ifo->$objid.cls= &gui_float_spinner_class;\n"
")\n"
"\n"

  );
  static int class_emitted=0;
  if (!class_emitted) {
     class_emitted= 1;
     tpl_append(T, tpl_new(
"\n"
"@library_interface\n"
"typedef struct gui_float_spinner gui_float_spinner_t;\n"
"\n"
"typedef struct {\n"
"  void (*set_value)(struct gui_float_spinner *,double );\n"
"  void (*get_value)(struct gui_float_spinner *,double *);\n"
"} gui_float_spinner_class_t;\n"
"\n"
"struct gui_float_spinner {\n"
"  gui_float_spinner_class_t *cls;\n"
"  void *widget;\n"
"};\n"
"\n"
"@library_code\n"
"\n"
"static void float_spinner_set_value(gui_float_spinner_t *B, double value)\n"
"{\n"
"  FXRealSpinner *W= (FXRealSpinner*) B->widget;\n"
"  W->setValue(value);\n"
"}\n"
"\n"
"static void float_spinner_get_value(gui_float_spinner_t *B, double *ret)\n"
"{\n"
"  FXRealSpinner *W= (FXRealSpinner*) B->widget;\n"
"  *ret= W->getValue();\n"
"}\n"
"\n"
"static gui_float_spinner_class_t\n"
" gui_float_spinner_class= {\n"
"  float_spinner_set_value,\n"
"  float_spinner_get_value,\n"
"};\n"
"\n"
"\n"

       ));
  }
     parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 
    if (!strcmp(kw,"objid")) {        char * K= parse_ident(P);
       tpl_replace(T,"$objid",K); continue; }
 if (!strcmp(kw,"pack_left")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_LEFT"); continue; }
if (!strcmp(kw,"pack_right")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_RIGHT"); continue; }
if (!strcmp(kw,"pack_top")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_TOP"); continue; }
if (!strcmp(kw,"pack_bottom")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_BOTTOM"); continue; }
if (!strcmp(kw,"stick_left")) { tpl_replace(T, "$layout_x", "LAYOUT_LEFT"); continue; }
if (!strcmp(kw,"stick_right")) { tpl_replace(T, "$layout_x", "LAYOUT_RIGHT"); continue; }
if (!strcmp(kw,"center_x")) { tpl_replace(T, "$layout_x", "LAYOUT_CENTER_X"); continue; }
if (!strcmp(kw,"stick_top")) { tpl_replace(T, "$layout_y", "LAYOUT_TOP"); continue; }
if (!strcmp(kw,"stick_bottom")) { tpl_replace(T, "$layout_y", "LAYOUT_BOTTOM"); continue; }
if (!strcmp(kw,"center_y")) { tpl_replace(T, "$layout_y", "LAYOUT_CENTER_Y"); continue; }
if (!strcmp(kw,"fill_x")) { tpl_replace(T, "$layout_fill_x", "LAYOUT_FILL_X"); continue; }
if (!strcmp(kw,"fill_y")) { tpl_replace(T, "$layout_fill_y", "LAYOUT_FILL_Y"); continue; }
 if (!strcmp(kw,"frame_none")) { tpl_replace(T, "$frame", "FRAME_NONE"); continue; }
if (!strcmp(kw,"frame_sunken")) { tpl_replace(T, "$frame", "FRAME_SUNKEN"); continue; }
if (!strcmp(kw,"frame_raised")) { tpl_replace(T, "$frame", "FRAME_RAISED"); continue; }
if (!strcmp(kw,"frame_thick")) { tpl_replace(T, "$frame", "FRAME_THICK"); continue; }
if (!strcmp(kw,"frame_ridge")) { tpl_replace(T, "$frame", "FRAME_RIDGE"); continue; }
if (!strcmp(kw,"frame_line")) { tpl_replace(T, "$frame", "FRAME_LINE"); continue; }
 
    if (!strcmp(kw,"pad_left")) {    tpl_replace_i(T, "$pad_left", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_right")) {    tpl_replace_i(T, "$pad_right", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_top")) {    tpl_replace_i(T, "$pad_top", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_bottom")) {    tpl_replace_i(T, "$pad_bottom", parse_int(P));
  continue; }
 
    if (!strcmp(kw,"max")) {        char *  K= parse_flo(P);
        tpl_replace(T,"$max", K);  continue; }

    if (!strcmp(kw,"min")) {        char *  K= parse_flo(P);
        tpl_replace(T,"$min", K);  continue; }

    if (!strcmp(kw,"increment")) {        char *  K= parse_flo(P);
        tpl_replace(T,"$increment", K);  continue; }

    // FIXME: maybe the max,min,increment fields can accept
    // C code instead of integer constants. This way I can
    // allow symbolic constants or run-time values.
    if (!strcmp(kw,"ncols")) {        int  K= parse_int(P);
        tpl_replace_i(T,"$ncols", K);  continue; }

      p_error(P,0, "unknown keyword %s.\n",kw);
  }
 
  tpl_builtin(T);
  return T;
}
#line 257 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 122 "/home/dodo/SFP/fxform-1.2/src/w_float_spinner.u"



