#line 158 "/home/dodo/SFP/fxform-1.2/src/w_text_field.u"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "template.h"
#include "parse.h"

#line 250 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 11 "w_text_field.c"


tpl_t* p_text_field(parser_t *P)
{
   tpl_t *T= tpl_new(
"\n"
"@form_constructor\n"
"\n"
"  FXTextField *$G_obj;\n"
"\n"
"  $def($objid)($objid =) $G_obj= \n"
"    new FXTextField($container,\n"
"      $dev($ncols)(40),\n"
"      $def($change_sig)(this) $nef($change_sig)(NULL),\n"
"      $def($change_sig)($G_selector) $nef($change_sig)(0),\n"
" \n"
"     $dev($layout_x)(LAYOUT_LEFT) |\n"
"     $dev($layout_y)(LAYOUT_TOP) |\n"
"     $dev($layout_side)(LAYOUT_SIDE_TOP) |\n"
"     $dev($layout_fill_x)(0) |\n"
"     $dev($layout_fill_y)(0) |\n"
"\n"
"    $dev($frame)(FRAME_SUNKEN|FRAME_THICK) |\n"
"    $dev($justify_x)(JUSTIFY_LEFT) |\n"
"    $dev($justify_y)(JUSTIFY_CENTER_Y)\n"
"    $dev($notify_enter_only)( )\n"
"    $dev($limit_length)( ) $dev($mode)( ) ,\n"
"\n"
"    0,0,0,0, // x,y,w,h\n"
"\n"
"    $dev($pad_left)(DEFAULT_PAD),\n"
"    $dev($pad_right)(DEFAULT_PAD),\n"
"    $dev($pad_top)(DEFAULT_PAD),\n"
"    $dev($pad_bottom)(DEFAULT_PAD));\n"
"\n"
"\n"
"@form_members\n"
"$def($change_sig)(long $G_change\n"
"       (FXObject *object,FXSelector sel, void *arg);)\n"
"$def($objid)(FXTextField *$objid;)\n"
"\n"
"@form_signal_mappings\n"
" $def($change_sig)(\n"
"   FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector, $form_class::$G_change),)\n"
"\n"
"@form_methods\n"
"\n"
"$def($change_sig)(\n"
"  long $form_class::$G_change\n"
"    (FXObject *object,FXSelector sel, void *arg)\n"
"       {\n"
"        const char *text= (const char*) arg;\n"
"         $change return 1;\n"
"       }\n"
")\n"
"\n"
"@form_selector_ids      $def($change_sig)($G_selector,)\n"
"\n"
"\n"
"@form_widget_declarations $def($objid)(gui_text_entry_t $objid;)\n"
"\n"
"@form_widget_export $def($objid)(\n"
" ifo->$objid.widget= ffo->$objid;\n"
" ifo->$objid.cls= &gui_text_entry_class;\n"
")\n"
"\n"

   );
      parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 
        // FIXME: justification shall be x-direction only
      if (!strcmp(kw,"pack_left")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_LEFT"); continue; }
if (!strcmp(kw,"pack_right")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_RIGHT"); continue; }
if (!strcmp(kw,"pack_top")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_TOP"); continue; }
if (!strcmp(kw,"pack_bottom")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_BOTTOM"); continue; }
if (!strcmp(kw,"stick_left")) { tpl_replace(T, "$layout_x", "LAYOUT_LEFT"); continue; }
if (!strcmp(kw,"stick_right")) { tpl_replace(T, "$layout_x", "LAYOUT_RIGHT"); continue; }
if (!strcmp(kw,"center_x")) { tpl_replace(T, "$layout_x", "LAYOUT_CENTER_X"); continue; }
if (!strcmp(kw,"stick_top")) { tpl_replace(T, "$layout_y", "LAYOUT_TOP"); continue; }
if (!strcmp(kw,"stick_bottom")) { tpl_replace(T, "$layout_y", "LAYOUT_BOTTOM"); continue; }
if (!strcmp(kw,"center_y")) { tpl_replace(T, "$layout_y", "LAYOUT_CENTER_Y"); continue; }
if (!strcmp(kw,"fill_x")) { tpl_replace(T, "$layout_fill_x", "LAYOUT_FILL_X"); continue; }
if (!strcmp(kw,"fill_y")) { tpl_replace(T, "$layout_fill_y", "LAYOUT_FILL_Y"); continue; }
 if (!strcmp(kw,"justify")) {    parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 if (!strcmp(kw,"center_x")) { tpl_replace(T, "$justify_x", "JUSTIFY_CENTER_X"); continue; }
if (!strcmp(kw,"left")) { tpl_replace(T, "$justify_x", "JUSTIFY_LEFT"); continue; }
if (!strcmp(kw,"right")) { tpl_replace(T, "$justify_x", "JUSTIFY_RIGHT"); continue; }
if (!strcmp(kw,"hz_apart")) { tpl_replace(T, "$justify_y", "JUSTIFY_HZ_APART"); continue; }
if (!strcmp(kw,"center_y")) { tpl_replace(T, "$justify_y", "JUSTIFY_CENTER_Y"); continue; }
if (!strcmp(kw,"top")) { tpl_replace(T, "$justify_y", "JUSTIFY_TOP"); continue; }
if (!strcmp(kw,"bottom")) { tpl_replace(T, "$justify_y", "JUSTIFY_BOTTOM"); continue; }
if (!strcmp(kw,"vt_apart")) { tpl_replace(T, "$justify_y", "JUSTIFY_VT_APART"); continue; }
    p_error(P,0, "unknown keyword %s.\n",kw);
  }
  continue; }
 if (!strcmp(kw,"frame_none")) { tpl_replace(T, "$frame", "FRAME_NONE"); continue; }
if (!strcmp(kw,"frame_sunken")) { tpl_replace(T, "$frame", "FRAME_SUNKEN"); continue; }
if (!strcmp(kw,"frame_raised")) { tpl_replace(T, "$frame", "FRAME_RAISED"); continue; }
if (!strcmp(kw,"frame_thick")) { tpl_replace(T, "$frame", "FRAME_THICK"); continue; }
if (!strcmp(kw,"frame_ridge")) { tpl_replace(T, "$frame", "FRAME_RIDGE"); continue; }
if (!strcmp(kw,"frame_line")) { tpl_replace(T, "$frame", "FRAME_LINE"); continue; }

      if (!strcmp(kw,"objid")) {        char * K= parse_ident(P);
       tpl_replace(T,"$objid",K); continue; }

      if (!strcmp(kw,"ncols")) {        int  K= parse_int(P);
        tpl_replace_i(T, "$ncols", K);  continue; }

      if (!strcmp(kw,"password_mode")) {  tpl_replace(T, "$mode", "| TEXTFIELD_PASSWD");  continue; }

      if (!strcmp(kw,"integer_mode")) {  tpl_replace(T, "$mode", "| TEXTFIELD_INTEGER");  continue; }

      if (!strcmp(kw,"real_mode")) {  tpl_replace(T, "$mode", "| TEXTFIELD_REAL");  continue; }

      if (!strcmp(kw,"limit_length")) {  tpl_replace(T, "$limit_length", "| TEXTFIELD_LIMITED");  continue; }

      if (!strcmp(kw,"notify_enter_only")) {  tpl_replace(T,"$notify_enter_only", "| TEXTFIELD_ENTER_ONLY");  continue; }

      if (!strcmp(kw,"change")) {  tpl_replace(T, "$change", parse_cpp(P));
                 tpl_replace(T, "$change_sig", "Y");  continue; }

       p_error(P,0, "unknown keyword %s.\n",kw);
  }
 
   static int lib_done= 0;
   if (!lib_done) {
     tpl_append(T, tpl_new(
"\n"
"@library_interface\n"
"typedef struct gui_text_entry gui_text_entry_t;\n"
"\n"
"typedef struct {\n"
"  void (*set_text)(struct gui_text_entry *,char *);\n"
"  char* (*get_text)(struct gui_text_entry *);\n"
"} gui_text_entry_class_t;\n"
"\n"
"struct gui_text_entry {\n"
"  gui_text_entry_class_t *cls;\n"
"  void *widget;\n"
"};\n"
"\n"
"@library_code\n"
"\n"
"static void text_entry_set_text(gui_text_entry_t *B, char *text)\n"
"{\n"
"  FXTextField *W= (FXTextField*) B->widget;\n"
"  W->setText(text);\n"
"}\n"
"\n"
"static char* text_entry_get_text(gui_text_entry_t *B)\n"
"{\n"
"  FXTextField *W= (FXTextField*) B->widget;\n"
"  FXString S= W->getText();\n"
"  return strdup(S.text());\n"
"}\n"
"\n"
"static \n"
" gui_text_entry_class_t gui_text_entry_class= {\n"
"   text_entry_set_text,\n"
"   text_entry_get_text\n"
"};\n"
"\n"

       ));
     lib_done= 1;
   }
   tpl_builtin(T);
   return T;
}

#line 257 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 166 "/home/dodo/SFP/fxform-1.2/src/w_text_field.u"

