#line 159 "/home/dodo/SFP/fxform-1.2/src/w_button.u"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "template.h"
#include "parse.h"
#include "icon.h"


#line 250 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 13 "w_button.c"


tpl_t *p_button(parser_t *P)
{
  tpl_t *T= tpl_new(
"\n"
"@form_constructor\n"
"\n"
"  FXButton *$G_obj;\n"
"\n"
"  $G_obj= $def($objid)($objid =)\n"
"    new FXButton($container,\n"
"      $dev($text)(\042\042),\n"
"      $dev($icon)(NULL),\n"
"      $def($click_sig)(this) $nef($click_sig)(NULL),\n"
"      $def($click_sig)($G_selector) $nef($click_sig)(0),\n"
"\n"
"        $dev($layout_x)(LAYOUT_LEFT) |\n"
"        $dev($layout_y)(LAYOUT_TOP) |\n"
"        $dev($layout_side)(LAYOUT_SIDE_TOP) |\n"
"        $dev($layout_fill_x)(0) |\n"
"        $dev($layout_fill_y)(0) |\n"
"\n"
"        $dev($frame)(FRAME_RAISED|FRAME_THICK) |\n"
"        $dev($iconpos)(ICON_BEFORE_TEXT) |\n"
"        $dev($justify_x)(JUSTIFY_CENTER_X) |\n"
"        $dev($justify_y)(JUSTIFY_CENTER_Y) \n"
"\n"
"        $def($toolbar_style)(| BUTTON_TOOLBAR)\n"
"\n"
"        $def($fixed_width)( | LAYOUT_FIX_WIDTH )\n"
"        $def($fixed_height)( | LAYOUT_FIX_HEIGHT )\n"
"        ,\n"
"\n"
"        0,0,$dev($fixed_width)(0),$dev($fixed_height)(0), // x,y,w,h\n"
"        $dev($pad_left)(DEFAULT_PAD),\n"
"        $dev($pad_right)(DEFAULT_PAD),\n"
"        $dev($pad_top)(DEFAULT_PAD),\n"
"        $dev($pad_bottom)(DEFAULT_PAD));\n"
"\n"
"  $def($font_size $font_family)(\n"
"     FXFontDesc $G_font_desc;\n"
"     $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"  )\n"
"\n"
"  $def($font_size)(\n"
"     $G_font_desc.size= $font_size * 10;\n"
"  )\n"
"\n"
"  $def($font_family)(\n"
"     strcpy($G_font_desc.face, $font_family);\n"
"  )\n"
"\n"
"  $def($font_size $font_family)(\n"
"    $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"    $G_obj->setFont($G_font);\n"
"    @library_code  static FXFont *$G_font;\n"
"    @GUI_object_creation  // $G_font->create(); \n"
"    @form_constructor\n"
"  )\n"
"\n"
"\n"
"   $def($bgcolor)( $G_obj->setBackColor($bgcolor); )\n"
"\n"
"         \n"
"\n"
"@form_members\n"
"\n"
"  $def($click_sig)(long $G_click(FXObject *object,FXSelector sel, void *arg);)\n"
"  $def($objid)(FXButton *$objid;)\n"
"\n"
"@form_signal_mappings\n"
" $def($click_sig)(\n"
"    FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector, $form_class::$G_click),)\n"
"\n"
"@form_methods\n"
"\n"
"$def($click_sig)(\n"
"  long $form_class::$G_click\n"
"    (FXObject *object,FXSelector sel, void *arg)\n"
"       { $click return 1; }\n"
")\n"
"\n"
"@form_selector_ids\n"
" $def($click_sig)($G_selector,)\n"
"\n"
"@form_widget_declarations $def($objid)(gui_button_t $objid;)\n"
"\n"
"@form_widget_export $def($objid)(ifo->$objid.widget= ffo->$objid;\n"
" ifo->$objid.cls= &gui_button_class;\n"
")\n"
"\n"
"\n"
"\n"

  );
  static int class_emitted=0;
  if (!class_emitted) {
     class_emitted= 1;
     tpl_append(T, tpl_new(
"\n"
"@library_interface\n"
"typedef struct gui_button gui_button_t;\n"
"\n"
"typedef struct {\n"
"  void (*set_text)(struct gui_button *,const char *);\n"
"} gui_button_class_t;\n"
"\n"
"struct gui_button {\n"
"  gui_button_class_t *cls;\n"
"  void *widget;\n"
"};\n"
"\n"
"@library_code\n"
"\n"
"static void button_set_text(gui_button_t *B,const char *text)\n"
"{\n"
"  FXButton *W= (FXButton*) B->widget;\n"
"  W->setText(text);\n"
"}\n"
"\n"
"static gui_button_class_t\n"
" gui_button_class= {\n"
"  button_set_text,\n"
"};\n"
"\n"
"\n"

       ));
  }
     parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 
    if (!strcmp(kw,"text")) {        char *  K= parse_strlit(P);
        tpl_replace(T,"$text", K);  continue; }

    if (!strcmp(kw,"objid")) {        char * K= parse_ident(P);
       tpl_replace(T,"$objid",K); continue; }

    if (!strcmp(kw,"pack_left")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_LEFT"); continue; }
if (!strcmp(kw,"pack_right")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_RIGHT"); continue; }
if (!strcmp(kw,"pack_top")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_TOP"); continue; }
if (!strcmp(kw,"pack_bottom")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_BOTTOM"); continue; }
if (!strcmp(kw,"stick_left")) { tpl_replace(T, "$layout_x", "LAYOUT_LEFT"); continue; }
if (!strcmp(kw,"stick_right")) { tpl_replace(T, "$layout_x", "LAYOUT_RIGHT"); continue; }
if (!strcmp(kw,"center_x")) { tpl_replace(T, "$layout_x", "LAYOUT_CENTER_X"); continue; }
if (!strcmp(kw,"stick_top")) { tpl_replace(T, "$layout_y", "LAYOUT_TOP"); continue; }
if (!strcmp(kw,"stick_bottom")) { tpl_replace(T, "$layout_y", "LAYOUT_BOTTOM"); continue; }
if (!strcmp(kw,"center_y")) { tpl_replace(T, "$layout_y", "LAYOUT_CENTER_Y"); continue; }
if (!strcmp(kw,"fill_x")) { tpl_replace(T, "$layout_fill_x", "LAYOUT_FILL_X"); continue; }
if (!strcmp(kw,"fill_y")) { tpl_replace(T, "$layout_fill_y", "LAYOUT_FILL_Y"); continue; }
 if (!strcmp(kw,"icon_before_text")) { tpl_replace(T, "$iconpos", "ICON_BEFORE_TEXT"); continue; }
if (!strcmp(kw,"icon_after_text")) { tpl_replace(T, "$iconpos", "ICON_AFTER_TEXT"); continue; }
if (!strcmp(kw,"icon_under_text")) { tpl_replace(T, "$iconpos", "ICON_UNDER_TEXT"); continue; }
if (!strcmp(kw,"icon_above_text")) { tpl_replace(T, "$iconpos", "ICON_ABOVE_TEXT"); continue; }

    if (!strcmp(kw,"frame_none")) { tpl_replace(T, "$frame", "FRAME_NONE"); continue; }
if (!strcmp(kw,"frame_sunken")) { tpl_replace(T, "$frame", "FRAME_SUNKEN"); continue; }
if (!strcmp(kw,"frame_raised")) { tpl_replace(T, "$frame", "FRAME_RAISED"); continue; }
if (!strcmp(kw,"frame_thick")) { tpl_replace(T, "$frame", "FRAME_THICK"); continue; }
if (!strcmp(kw,"frame_ridge")) { tpl_replace(T, "$frame", "FRAME_RIDGE"); continue; }
if (!strcmp(kw,"frame_line")) { tpl_replace(T, "$frame", "FRAME_LINE"); continue; }
 if (!strcmp(kw,"justify")) {    parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 if (!strcmp(kw,"center_x")) { tpl_replace(T, "$justify_x", "JUSTIFY_CENTER_X"); continue; }
if (!strcmp(kw,"left")) { tpl_replace(T, "$justify_x", "JUSTIFY_LEFT"); continue; }
if (!strcmp(kw,"right")) { tpl_replace(T, "$justify_x", "JUSTIFY_RIGHT"); continue; }
if (!strcmp(kw,"hz_apart")) { tpl_replace(T, "$justify_y", "JUSTIFY_HZ_APART"); continue; }
if (!strcmp(kw,"center_y")) { tpl_replace(T, "$justify_y", "JUSTIFY_CENTER_Y"); continue; }
if (!strcmp(kw,"top")) { tpl_replace(T, "$justify_y", "JUSTIFY_TOP"); continue; }
if (!strcmp(kw,"bottom")) { tpl_replace(T, "$justify_y", "JUSTIFY_BOTTOM"); continue; }
if (!strcmp(kw,"vt_apart")) { tpl_replace(T, "$justify_y", "JUSTIFY_VT_APART"); continue; }
    p_error(P,0, "unknown keyword %s.\n",kw);
  }
  continue; }

    if (!strcmp(kw,"pad_left")) {    tpl_replace_i(T, "$pad_left", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_right")) {    tpl_replace_i(T, "$pad_right", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_top")) {    tpl_replace_i(T, "$pad_top", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_bottom")) {    tpl_replace_i(T, "$pad_bottom", parse_int(P));
  continue; }

    if (!strcmp(kw,"font")) {    parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 if (!strcmp(kw,"size")) {        int sz= parse_int(P);
        tpl_replace_i(T, "$font_size", sz); continue; }
if (!strcmp(kw,"family")) {        char * fm= parse_strlit(P);
        tpl_replace(T, "$font_family", fm); continue; }
    p_error(P,0, "unknown keyword %s.\n",kw);
  }
  continue; }

    if (!strcmp(kw,"bgcolor")) {  tpl_replace(T, "$bgcolor", parse_color(P));  continue; }

    if (!strcmp(kw,"click")) {  tpl_replace(T,"$click", parse_cpp(P));
              tpl_replace(T,"$click_sig", "Y");  continue; }

    if (!strcmp(kw,"fixed_width")) {  tpl_replace_i(T, "$fixed_width", parse_int(P));  continue; }

    if (!strcmp(kw,"fixed_height")) {  tpl_replace_i(T, "$fixed_height", parse_int(P));  continue; }

    if (!strcmp(kw,"icon")) {  put_icon(T, "$icon", P);  continue; }

    if (!strcmp(kw,"toolbar_style")) {  tpl_replace(T,"$toolbar","y");  continue; }

      p_error(P,0, "unknown keyword %s.\n",kw);
  }
 

  tpl_builtin(T);
  return T;
}

#line 257 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

