#line 211 "/home/dodo/SFP/fxform-1.2/src/w_dirlist.u"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "template.h"
#include "parse.h"

#line 52 "/home/dodo/SFP/fxform-1.2/src/w_dirlist.u"

static tpl_t *dirlist_code()
{
  tpl_t *T= tpl_new(
#line 14 "w_dirlist.c"
"\n"
"@form_constructor\n"
"\n"
"  FXDirList *$G_obj;\n"
"  $G_obj= $def($objid)($objid =) new FXDirList($container,\n"
"           $def($click_sig)(this) $nef($click_sig)(NULL),\n"
"           $def($click_sig)($G_selector) $nef($click_sig)(0),\n"
"             TREELIST_SHOWS_LINES|TREELIST_SHOWS_BOXES|TREELIST_BROWSESELECT|\n"
"             DIRLIST_NO_OWN_ASSOC |\n"
"             $dev($show_files)(0) |\n"
"             $dev($show_hidden)(0) |\n"
"\n"
"             $dev($layout_x)(LAYOUT_LEFT) |\n"
"             $dev($layout_y)(LAYOUT_TOP) |\n"
"             $dev($layout_side)(LAYOUT_SIDE_TOP) |\n"
"             $dev($layout_fill_x)(0) |\n"
"             $dev($layout_fill_y)(0) |\n"
"             $dev($frame)(FRAME_RAISED|FRAME_THICK) \n"
"           ,0,0,0,0);  // xywh\n"
"\n"
"  $def($font_size $font_family)(\n"
"     FXFontDesc $G_font_desc;\n"
"     $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"  )\n"
"\n"
"  $def($font_size)(\n"
"     $G_font_desc.size= $font_size * 10;\n"
"  )\n"
"\n"
"  $def($font_family)(\n"
"     strcpy($G_font_desc.face, $font_family);\n"
"  )\n"
"\n"
"  $def($font_size $font_family)(\n"
"    $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"    $G_obj->setFont($G_font);\n"
"    @library_code  static FXFont *$G_font;\n"
"    @GUI_object_creation  // $G_font->create(); \n"
"    @form_constructor\n"
"  )\n"
"\n"
"\n"
"@form_members\n"
"   $def($objid)(FXDirList *$objid;)\n"
"   $def($click_sig)(\n"
"       long $G_click(FXObject *object, FXSelector sel, void *arg);)\n"
"\n"
"@form_signal_mappings\n"
"\n"
"  $def($click_sig)(\n"
"    FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector, $form_class::$G_click), )\n"
"\n"
"@form_methods\n"
"\n"
"  $def($click_sig)(\n"
"long $form_class::$G_click\n"
"     (FXObject *object, FXSelector sel, void *arg)\n"
"{\n"
"   $click\n"
"   return 1;\n"
"}\n"
"  )\n"
"\n"
"@form_selector_ids\n"
"  $def($click_sig)($G_selector,)\n"
"\n"
"@form_widget_declarations \n"
"  $def($objid)(gui_dir_list_t $objid;)\n"
"\n"
"@form_widget_export\n"
"  $def($objid)(\n"
"    ifo->$objid.widget= ffo->$objid;\n"
"    ifo->$objid.cls= &gui_dir_list_class;\n"
"  )\n"

#line 59 "/home/dodo/SFP/fxform-1.2/src/w_dirlist.u"
  );
  static int class_done= 0;
  if (!class_done) {
   class_done= 1;
   tpl_append(T, tpl_new(
#line 95 "w_dirlist.c"
"\n"
"@library_interface\n"
"\n"
"typedef struct gui_dir_list gui_dir_list_t;\n"
"\n"
"typedef struct {\n"
"   int (*get_current)(gui_dir_list_t *, const char **, int *);\n"
"   void (*set_current_file)(gui_dir_list_t* , const char*);\n"
"   void (*set_current_dir)(gui_dir_list_t* , const char*);\n"
"} gui_dir_list_class_t;\n"
"\n"
"struct gui_dir_list\n"
"{\n"
"   gui_dir_list_class_t *cls;\n"
"   void *widget;\n"
"};\n"
"\n"
"\n"
"@library_code\n"
"\n"
"static int item_type(FXDirItem *item)\n"
"{\n"
"  if (item->isDirectory()) return \047D\047;\n"
"  if (item->isSymlink())   return \047L\047;\n"
"  if (item->isChardev())   return \047C\047;\n"
"  if (item->isBlockdev())  return \047B\047;\n"
"  if (item->isFifo())      return \047P\047;\n"
"  if (item->isSocket())    return \047S\047;\n"
"  return \047F\047;\n"
"}\n"
"\n"
"static int dirlist_get_current\n"
"  (gui_dir_list_t* DL, const char **Rname, int *Rtype)\n"
"{\n"
"  FXDirList *L= (FXDirList*) DL->widget;\n"
"  FXDirItem *item= (FXDirItem*) L->getCurrentItem();\n"
"  if (!item) return 0;\n"
"  if (Rname) *Rname= strdup(L->getItemPathname(item).text());\n"
"  if (Rtype) *Rtype= item_type(item);\n"
"  return 1;\n"
"}\n"
"\n"
"static void dirlist_set_current_file\n"
"  (gui_dir_list_t *DL, const char *fn)\n"
"{\n"
"  FXDirList *L= (FXDirList*) DL->widget;\n"
"  L->setCurrentFile(fn);\n"
"}\n"
"\n"
"static void dirlist_set_current_directory\n"
"  (gui_dir_list_t *DL, const char *fn)\n"
"{\n"
"  FXDirList *L= (FXDirList*) DL->widget;\n"
"  L->setDirectory(fn);\n"
"}\n"
"\n"
"static gui_dir_list_class_t gui_dir_list_class= {\n"
"   dirlist_get_current,\n"
"   dirlist_set_current_file,\n"
"   dirlist_set_current_directory \n"
"};\n"
"\n"

#line 67 "/home/dodo/SFP/fxform-1.2/src/w_dirlist.u"
   ));
  }
  return T;
}

#line 250 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 166 "w_dirlist.c"


tpl_t* p_dir_list(parser_t *P)
{
  tpl_t *T= dirlist_code();
     parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 
    if (!strcmp(kw,"show_hidden")) {  tpl_replace(T,"$show_hidden", "DIRLIST_SHOWHIDDEN");  continue; }

    if (!strcmp(kw,"show_files")) {  tpl_replace(T,"$show_files", "DIRLIST_SHOWFILES");  continue; }

    if (!strcmp(kw,"objid")) {        char * K= parse_ident(P);
       tpl_replace(T,"$objid",K); continue; }
 if (!strcmp(kw,"pack_left")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_LEFT"); continue; }
if (!strcmp(kw,"pack_right")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_RIGHT"); continue; }
if (!strcmp(kw,"pack_top")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_TOP"); continue; }
if (!strcmp(kw,"pack_bottom")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_BOTTOM"); continue; }
if (!strcmp(kw,"stick_left")) { tpl_replace(T, "$layout_x", "LAYOUT_LEFT"); continue; }
if (!strcmp(kw,"stick_right")) { tpl_replace(T, "$layout_x", "LAYOUT_RIGHT"); continue; }
if (!strcmp(kw,"center_x")) { tpl_replace(T, "$layout_x", "LAYOUT_CENTER_X"); continue; }
if (!strcmp(kw,"stick_top")) { tpl_replace(T, "$layout_y", "LAYOUT_TOP"); continue; }
if (!strcmp(kw,"stick_bottom")) { tpl_replace(T, "$layout_y", "LAYOUT_BOTTOM"); continue; }
if (!strcmp(kw,"center_y")) { tpl_replace(T, "$layout_y", "LAYOUT_CENTER_Y"); continue; }
if (!strcmp(kw,"fill_x")) { tpl_replace(T, "$layout_fill_x", "LAYOUT_FILL_X"); continue; }
if (!strcmp(kw,"fill_y")) { tpl_replace(T, "$layout_fill_y", "LAYOUT_FILL_Y"); continue; }
 if (!strcmp(kw,"font")) {    parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 if (!strcmp(kw,"size")) {        int sz= parse_int(P);
        tpl_replace_i(T, "$font_size", sz); continue; }
if (!strcmp(kw,"family")) {        char * fm= parse_strlit(P);
        tpl_replace(T, "$font_family", fm); continue; }
    p_error(P,0, "unknown keyword %s.\n",kw);
  }
  continue; }
 if (!strcmp(kw,"frame_none")) { tpl_replace(T, "$frame", "FRAME_NONE"); continue; }
if (!strcmp(kw,"frame_sunken")) { tpl_replace(T, "$frame", "FRAME_SUNKEN"); continue; }
if (!strcmp(kw,"frame_raised")) { tpl_replace(T, "$frame", "FRAME_RAISED"); continue; }
if (!strcmp(kw,"frame_thick")) { tpl_replace(T, "$frame", "FRAME_THICK"); continue; }
if (!strcmp(kw,"frame_ridge")) { tpl_replace(T, "$frame", "FRAME_RIDGE"); continue; }
if (!strcmp(kw,"frame_line")) { tpl_replace(T, "$frame", "FRAME_LINE"); continue; }

    if (!strcmp(kw,"click")) {  tpl_replace(T,"$click", parse_cpp(P));
              tpl_replace(T,"$click_sig", "Y");  continue; }

      p_error(P,0, "unknown keyword %s.\n",kw);
  }
 
  // FIXME: things to do: colors may also be set: selection, normal, background
  // There are options for showing/not showing the lines etc, for now
  // I will show them always, but this may change later, when I need
  // no-lines or no-boxes display
  tpl_builtin(T);
  return T;
}


#line 257 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 220 "/home/dodo/SFP/fxform-1.2/src/w_dirlist.u"

