#line 234 "/home/dodo/SFP/fxform-1.2/src/w_filelist.u"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "template.h"
#include "parse.h"

#line 34 "/home/dodo/SFP/fxform-1.2/src/w_filelist.u"

static tpl_t *filelist_code()
{
  tpl_t *T= tpl_new(
#line 14 "w_filelist.c"
"\n"
"@form_constructor\n"
"\n"
"  FXFileList *$G_obj;\n"
"  $G_obj= $def($objid)($objid =) new FXFileList($container,\n"
"           $def($click_sig $dclick_sig)(this) $nef($click_sig $dclick_sig)(NULL),\n"
"           $def($click_sig $dclick_sig)($G_selector) $nef($click_sig $dclick_sig)(0),\n"
"             FILELIST_NO_OWN_ASSOC |\n"
"             $dev($show_hidden)(0) |\n"
"             $dev($no_parent)(0) |\n"
"\n"
"             $dev($layout_x)(LAYOUT_LEFT) |\n"
"             $dev($layout_y)(LAYOUT_TOP) |\n"
"             $dev($layout_side)(LAYOUT_SIDE_TOP) |\n"
"             $dev($layout_fill_x)(0) |\n"
"             $dev($layout_fill_y)(0) |\n"
"             $dev($frame)(FRAME_RAISED|FRAME_THICK) \n"
"           ,0,0,0,0);  // xywh\n"
"\n"
"  $def($font_size $font_family)(\n"
"     FXFontDesc $G_font_desc;\n"
"     $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"  )\n"
"\n"
"  $def($font_size)(\n"
"     $G_font_desc.size= $font_size * 10;\n"
"  )\n"
"\n"
"  $def($font_family)(\n"
"     strcpy($G_font_desc.face, $font_family);\n"
"  )\n"
"\n"
"  $def($font_size $font_family)(\n"
"    $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"    $G_obj->setFont($G_font);\n"
"    @library_code  static FXFont *$G_font;\n"
"    @GUI_object_creation  // $G_font->create(); \n"
"    @form_constructor\n"
"  )\n"
"\n"
"\n"
"@form_members\n"
"   $def($objid)(FXFileList *$objid;)\n"
"   $def($click_sig)(long $G_click(FXObject *object,FXSelector sel,void *arg);)\n"
"   $def($dclick_sig)(long $G_dclick(FXObject *object,FXSelector sel,void *arg);)\n"
"\n"
"@form_signal_mappings\n"
"\n"
"  $def($click_sig)(\n"
"    FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector, $form_class::$G_click), )\n"
"  $def($dclick_sig)(\n"
"    FXMAPFUNC(SEL_DOUBLECLICKED, $form_class::$G_selector, $form_class::$G_dclick), )\n"
"\n"
"@form_methods\n"
"\n"
"  $def($click_sig)(\n"
"long $form_class::$G_click\n"
"     (FXObject *object, FXSelector sel, void *arg)\n"
"{\n"
"   FXFileList *$G_Ylist= (FXFileList*) object;\n"
"   int $G_clicked_item= (intptr_t) arg;\n"
"   FXString $G_path= $G_Ylist->getItemPathname($G_clicked_item);\n"
"   const char *clicked_path=$G_path.text(); \n"
"   FXString $G_fname= $G_Ylist->getItemFilename($G_clicked_item);\n"
"   const char *clicked_name= $G_fname.text();\n"
"   if ($G_Ylist->isItemFile($G_clicked_item))\n"
"   {\n"
"      $click_file\n"
"      return 1;\n"
"   }\n"
"   if ($G_Ylist->isItemDirectory($G_clicked_item))\n"
"   {\n"
"      $click_dir\n"
"      return 1;\n"
"   }\n"
"   return 1;\n"
"}\n"
"  )\n"
"\n"
"\n"
"  $def($dclick_sig)(\n"
"long $form_class::$G_dclick\n"
"     (FXObject *object, FXSelector sel, void *arg)\n"
"{\n"
"   FXFileList *$G_Ylist= (FXFileList*) object;\n"
"   int $G_clicked_item= (intptr_t) arg;\n"
"   FXString $G_path= $G_Ylist->getItemPathname($G_clicked_item);\n"
"   const char *clicked_path=$G_path.text(); \n"
"   FXString $G_fname= $G_Ylist->getItemFilename($G_clicked_item);\n"
"   const char *clicked_name= $G_fname.text();\n"
"   if ($G_Ylist->isItemFile($G_clicked_item))\n"
"   {\n"
"      $dclick_file\n"
"      return 1;\n"
"   }\n"
"   if ($G_Ylist->isItemDirectory($G_clicked_item))\n"
"   {\n"
"      $dclick_dir\n"
"      return 1;\n"
"   }\n"
"   return 1;\n"
"}\n"
"  )\n"
"\n"
"@form_selector_ids\n"
"  $def($click_sig $dclick_sig)($G_selector,)\n"
"\n"
"@form_widget_declarations \n"
"  $def($objid)(gui_file_list_t $objid;)\n"
"\n"
"@form_widget_export\n"
"  $def($objid)(\n"
"    ifo->$objid.widget= ffo->$objid;\n"
"    ifo->$objid.cls= &gui_file_list_class;\n"
"  )\n"

#line 41 "/home/dodo/SFP/fxform-1.2/src/w_filelist.u"
  );
  static int class_done= 0;
  if (!class_done) {
   class_done= 1;
   tpl_append(T, tpl_new(
#line 136 "w_filelist.c"
"\n"
"@library_interface\n"
"\n"
"typedef struct gui_file_list gui_file_list_t;\n"
"\n"
"typedef struct {\n"
"   int (*get_current)(gui_file_list_t *, const char **, int *);\n"
"   void (*set_current_file)(gui_file_list_t* , const char*);\n"
"   void (*set_current_dir)(gui_file_list_t* , const char*);\n"
"   void (*get_current_dir)(gui_file_list_t* , const char**);\n"
"} gui_file_list_class_t;\n"
"\n"
"struct gui_file_list\n"
"{\n"
"   gui_file_list_class_t *cls;\n"
"   void *widget;\n"
"};\n"
"\n"
"\n"
"@library_code\n"
"\n"
"static int item_type(FXFileList *L, int item)\n"
"{\n"
"  if (L->isItemDirectory(item)) return \047D\047;\n"
"  return \047F\047;\n"
"}\n"
"\n"
"static int filelist_get_current\n"
"  (gui_file_list_t* DL, const char **Rname, int *Rtype)\n"
"{\n"
"  FXFileList *L= (FXFileList*) DL->widget;\n"
"  FXString cur;\n"
"  int item;\n"
"\n"
"  item= L->getCurrentItem();\n"
"  if (item<0) return 0;\n"
"  cur= L->getCurrentFile();\n"
"  if (Rname) *Rname= strdup(cur.text());\n"
"  if (Rtype) *Rtype= item_type(L,item);\n"
"  return 1;\n"
"}\n"
"\n"
"static void filelist_set_current_file\n"
"  (gui_file_list_t *FL, const char *fn)\n"
"{\n"
"  FXFileList *L= (FXFileList*) FL->widget;\n"
"  L->setCurrentFile(fn);\n"
"}\n"
"\n"
"static void filelist_set_current_directory\n"
"  (gui_file_list_t *DL, const char *fn)\n"
"{\n"
"  FXFileList *L= (FXFileList*) DL->widget;\n"
"  L->setDirectory(fn);\n"
"}\n"
"\n"
"static void filelist_get_current_directory\n"
"  (gui_file_list_t* DL, const char **Rname)\n"
"{\n"
"  FXFileList *L= (FXFileList*) DL->widget;\n"
"  FXString cur;\n"
"\n"
"  cur= L->getDirectory();\n"
"  if (Rname) *Rname= strdup(cur.text());\n"
"}\n"
"\n"
"static gui_file_list_class_t gui_file_list_class= {\n"
"   filelist_get_current,\n"
"   filelist_set_current_file,\n"
"   filelist_set_current_directory,\n"
"   filelist_get_current_directory,\n"
"};\n"
"\n"

#line 49 "/home/dodo/SFP/fxform-1.2/src/w_filelist.u"
   ));
  }
  return T;
}

#line 250 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 218 "w_filelist.c"


tpl_t* p_file_list(parser_t *P)
{
  tpl_t *T= filelist_code();
     parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 
    if (!strcmp(kw,"show_hidden")) {  tpl_replace(T,"$show_hidden", "FILELIST_SHOWHIDDEN");  continue; }

    if (!strcmp(kw,"no_parent")) {  tpl_replace(T,"$no_parent", "FILELIST_NO_PARENT");  continue; }

    if (!strcmp(kw,"objid")) {        char * K= parse_ident(P);
       tpl_replace(T,"$objid",K); continue; }
 if (!strcmp(kw,"pack_left")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_LEFT"); continue; }
if (!strcmp(kw,"pack_right")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_RIGHT"); continue; }
if (!strcmp(kw,"pack_top")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_TOP"); continue; }
if (!strcmp(kw,"pack_bottom")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_BOTTOM"); continue; }
if (!strcmp(kw,"stick_left")) { tpl_replace(T, "$layout_x", "LAYOUT_LEFT"); continue; }
if (!strcmp(kw,"stick_right")) { tpl_replace(T, "$layout_x", "LAYOUT_RIGHT"); continue; }
if (!strcmp(kw,"center_x")) { tpl_replace(T, "$layout_x", "LAYOUT_CENTER_X"); continue; }
if (!strcmp(kw,"stick_top")) { tpl_replace(T, "$layout_y", "LAYOUT_TOP"); continue; }
if (!strcmp(kw,"stick_bottom")) { tpl_replace(T, "$layout_y", "LAYOUT_BOTTOM"); continue; }
if (!strcmp(kw,"center_y")) { tpl_replace(T, "$layout_y", "LAYOUT_CENTER_Y"); continue; }
if (!strcmp(kw,"fill_x")) { tpl_replace(T, "$layout_fill_x", "LAYOUT_FILL_X"); continue; }
if (!strcmp(kw,"fill_y")) { tpl_replace(T, "$layout_fill_y", "LAYOUT_FILL_Y"); continue; }
 if (!strcmp(kw,"font")) {    parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 if (!strcmp(kw,"size")) {        int sz= parse_int(P);
        tpl_replace_i(T, "$font_size", sz); continue; }
if (!strcmp(kw,"family")) {        char * fm= parse_strlit(P);
        tpl_replace(T, "$font_family", fm); continue; }
    p_error(P,0, "unknown keyword %s.\n",kw);
  }
  continue; }
 if (!strcmp(kw,"frame_none")) { tpl_replace(T, "$frame", "FRAME_NONE"); continue; }
if (!strcmp(kw,"frame_sunken")) { tpl_replace(T, "$frame", "FRAME_SUNKEN"); continue; }
if (!strcmp(kw,"frame_raised")) { tpl_replace(T, "$frame", "FRAME_RAISED"); continue; }
if (!strcmp(kw,"frame_thick")) { tpl_replace(T, "$frame", "FRAME_THICK"); continue; }
if (!strcmp(kw,"frame_ridge")) { tpl_replace(T, "$frame", "FRAME_RIDGE"); continue; }
if (!strcmp(kw,"frame_line")) { tpl_replace(T, "$frame", "FRAME_LINE"); continue; }

    if (!strcmp(kw,"click_file")) {  tpl_replace(T,"$click_file", parse_cpp(P));
                   tpl_replace(T,"$click_sig", "Y");  continue; }

    if (!strcmp(kw,"click_dir")) {   tpl_replace(T,"$click_dir", parse_cpp(P));
                   tpl_replace(T,"$click_sig", "Y");  continue; }

    if (!strcmp(kw,"dclick_file")) { tpl_replace(T,"$dclick_file", parse_cpp(P));
                   tpl_replace(T,"$dclick_sig", "Y");  continue; }

    if (!strcmp(kw,"dclick_dir")) {  tpl_replace(T,"$dclick_dir", parse_cpp(P));
                   tpl_replace(T,"$dclick_sig", "Y");  continue; }

      p_error(P,0, "unknown keyword %s.\n",kw);
  }
 
  tpl_builtin(T);
  tpl_replace(T,"$click_file", "");
  tpl_replace(T,"$click_dir", "");
  tpl_replace(T,"$dclick_file", "");
  tpl_replace(T,"$dclick_dir", "");
  return T;
}


#line 257 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 243 "/home/dodo/SFP/fxform-1.2/src/w_filelist.u"

