#line 61 "/home/dodo/SFP/fxform-1.2/src/w_groupbox.u"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "template.h"
#include "parse.h"

#line 250 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 11 "w_groupbox.c"


tpl_t* p_group_box(parser_t *P)
{
   tpl_t *T= tpl_new(
"@form_constructor\n"
"  FXGroupBox *$G_obj;\n"
"  $G_obj= new FXGroupBox($container, $dev($title)(\042\042), \n"
"        GROUPBOX_TITLE_LEFT |  // FIXME: this shall be configurable\n"
"        $dev($layout_x)(LAYOUT_LEFT) |\n"
"        $dev($layout_y)(LAYOUT_TOP) |\n"
"        $dev($layout_side)(LAYOUT_SIDE_TOP) |\n"
"        $dev($layout_fill_x)(0) |\n"
"        $dev($layout_fill_y)(0) |\n"
"        $dev($frame)(FRAME_LINE) |\n"
"        $dev($justify_x)(JUSTIFY_CENTER_X) |\n"
"        $dev($justify_y)(JUSTIFY_CENTER_Y) ,\n"
"     0,0,0,0, // xywh\n"
"        $dev($pad_left)(DEFAULT_SPACING),\n"
"        $dev($pad_right)(DEFAULT_SPACING),\n"
"        $dev($pad_top)(DEFAULT_SPACING),\n"
"        $dev($pad_bottom)(DEFAULT_SPACING),\n"
"        $dev($hz_spacing)(DEFAULT_SPACING),\n"
"        $dev($vt_spacing)(DEFAULT_SPACING));\n"
"\n"

   );
      parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 
    if (!strcmp(kw,"pack_left")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_LEFT"); continue; }
if (!strcmp(kw,"pack_right")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_RIGHT"); continue; }
if (!strcmp(kw,"pack_top")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_TOP"); continue; }
if (!strcmp(kw,"pack_bottom")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_BOTTOM"); continue; }
if (!strcmp(kw,"stick_left")) { tpl_replace(T, "$layout_x", "LAYOUT_LEFT"); continue; }
if (!strcmp(kw,"stick_right")) { tpl_replace(T, "$layout_x", "LAYOUT_RIGHT"); continue; }
if (!strcmp(kw,"center_x")) { tpl_replace(T, "$layout_x", "LAYOUT_CENTER_X"); continue; }
if (!strcmp(kw,"stick_top")) { tpl_replace(T, "$layout_y", "LAYOUT_TOP"); continue; }
if (!strcmp(kw,"stick_bottom")) { tpl_replace(T, "$layout_y", "LAYOUT_BOTTOM"); continue; }
if (!strcmp(kw,"center_y")) { tpl_replace(T, "$layout_y", "LAYOUT_CENTER_Y"); continue; }
if (!strcmp(kw,"fill_x")) { tpl_replace(T, "$layout_fill_x", "LAYOUT_FILL_X"); continue; }
if (!strcmp(kw,"fill_y")) { tpl_replace(T, "$layout_fill_y", "LAYOUT_FILL_Y"); continue; }

    if (!strcmp(kw,"vt_spacing")) {    tpl_replace_i(T, "$vt_spacing", parse_int(P));
  continue; }
if (!strcmp(kw,"hz_spacing")) {    tpl_replace_i(T, "$hz_spacing", parse_int(P));
  continue; }

    if (!strcmp(kw,"pad_left")) {    tpl_replace_i(T, "$pad_left", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_right")) {    tpl_replace_i(T, "$pad_right", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_top")) {    tpl_replace_i(T, "$pad_top", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_bottom")) {    tpl_replace_i(T, "$pad_bottom", parse_int(P));
  continue; }

    if (!strcmp(kw,"title")) {        char * K= parse_strlit(P);
        tpl_replace(T, "$title", K);  continue; }

    tpl_t *child= parse_sub_widget(P,kw);
    if (child) {
     tpl_replace_var(child, "$container", "$G_obj");
     // the semantics of this function is very important
     // the unknown sections are appended to this widget's code
     // and therefore follow the construction of this code.
     tpl_relocations(T, child);
     continue;
    }
       p_error(P,0, "unknown keyword %s.\n",kw);
  }
 
   tpl_builtin(T);
   return T;
}

#line 257 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 69 "/home/dodo/SFP/fxform-1.2/src/w_groupbox.u"

