#line 173 "/home/dodo/SFP/fxform-1.2/src/w_main_window.u"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "template.h"
#include "parse.h"

#line 10 "w_main_window.c"

static char *p_mainwindow_decorations(parser_t *P);
#line 184 "/home/dodo/SFP/fxform-1.2/src/w_main_window.u"

#line 250 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 16 "w_main_window.c"


tpl_t *p_main_window(parser_t *P)
{
   char *form_class_name= 0;
   tpl_t *T= tpl_new(
"\n"
"@top_level_interface\n"
"\n"
"typedef struct {\n"
"  void *self;\n"
"  <form_widget_declarations>\n"
"} gui_$T($objid)_t;\n"
"\n"
"#ifdef __cplusplus\n"
"extern \042C\042 {\n"
"#endif\n"
"\n"
"gui_$T($objid)_t *gui_c_$objid();\n"
"\n"
"#ifdef __cplusplus\n"
"}\n"
"#endif\n"
"\n"
"@form_types\n"
"\n"
" class $form_class: public FXMainWindow\n"
" {\n"
"  FXDECLARE($form_class)\n"
" public:\n"
"  enum { ID_FIRST= FXMainWindow::ID_LAST,\n"
"         ID_SELF,\n"
"         <form_selector_ids> };\n"
"  <form_members>\n"
"  $form_class(FXApp* a,const FXString& name,\n"
"         FXIcon *ic,FXIcon *mi,FXuint opts,\n"
"         FXint x,FXint y,FXint w,FXint h,\n"
"         FXint pl,FXint pr,FXint pt,FXint pb,\n"
"         FXint hs,FXint vs);\n"
"  virtual ~$form_class();\n"
"  $form_class() : FXMainWindow() { }\n"
"  long handle_close(FXObject *object,FXSelector sel, void *arg);\n"
" };\n"
"\n"
" FXDEFMAP($form_class) $G_map []= {\n"
"  FXMAPFUNC(SEL_CLOSE, $form_class::ID_SELF, $form_class::handle_close),\n"
"  <form_signal_mappings>\n"
" }; \n"
"\n"
" FXIMPLEMENT($form_class, FXMainWindow, $G_map, ARRAYNUMBER($G_map))\n"
"\n"
" // FIXME: the argument names must be changed so that\n"
" // we can have widgets called \047y\047 etc.\n"
" $form_class::$form_class(\n"
"         FXApp* a,const FXString& name,\n"
"         FXIcon *ic,FXIcon *mi,FXuint opts,\n"
"         FXint x,FXint y,FXint w,FXint h,\n"
"         FXint pl,FXint pr,FXint pt,FXint pb,\n"
"         FXint hs,FXint vs) :\n"
"               FXMainWindow(a,name, ic,mi,opts,\n"
"                            x,y,w,h, pl,pr,pt,pb, hs,vs)\n"
"\n"
" {\n"
"   setTarget(this);\n"
"   setSelector(ID_SELF);\n"
"   <form_constructor>\n"
" }\n"
" $form_class:: ~ $form_class() { }\n"
" long $form_class::handle_close\n"
"    (FXObject *object,FXSelector sel, void *arg)\n"
" {\n"
"    $dev($close_code)(/* window closing code would go here */)\n"
"    return 0;\n"
" } \n"
" <form_methods>\n"
"\n"
"\n"
"@top_level_code \n"
"\n"
" gui_$T($objid)_t *gui_c_$objid()\n"
" {\n"
"    // ffo -> fox form object\n"
"    // ifo -> interface form object \n"
"   $form_class *ffo;\n"
"   gui_$T($objid)_t * ifo;\n"
"   ffo= new $form_class(\n"
"       FXApp::instance(),\n"
"       $dev($title)(\042Main Window\042),\n"
"       NULL, NULL, // FIXME: icons\n"
"       $dev($decorations)(DECOR_ALL) ,\n"
"       $dev($pos_x)(0), $dev($pos_y)(0),\n"
"       $dev($default_width)(400), $dev($default_height)(400),\n"
"       $dev($pad_left)(0), $dev($pad_right)(0),\n"
"       $dev($pad_top)(0), $dev($pad_bottom)(0),\n"
"       $dev($hz_spacing)(0), $dev($vt_spacing)(0));\n"
"   // If the application has not been created, this will done\n"
"   // when the application gets created. Otherwise, we have\n"
"   // to explicitly do this.\n"
"   if (app_created) \n"
"     ffo->create();\n"
"   \n"
"   ffo->show(PLACEMENT_SCREEN);\n"
"\n"
"   ifo= (typeof(ifo)) malloc(sizeof(*ifo));\n"
"   ifo->self= ffo;\n"
"   <form_widget_export>\n"
"   return ifo;\n"
" }\n"
"\n"
"\n"

   );
      parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 
     if (!strcmp(kw,"decorations")) {  tpl_replace(T,"decorations",
                              p_mainwindow_decorations(P));  continue; }

     if (!strcmp(kw,"pad_left")) {    tpl_replace_i(T, "$pad_left", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_right")) {    tpl_replace_i(T, "$pad_right", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_top")) {    tpl_replace_i(T, "$pad_top", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_bottom")) {    tpl_replace_i(T, "$pad_bottom", parse_int(P));
  continue; }
 if (!strcmp(kw,"vt_spacing")) {    tpl_replace_i(T, "$vt_spacing", parse_int(P));
  continue; }
if (!strcmp(kw,"hz_spacing")) {    tpl_replace_i(T, "$hz_spacing", parse_int(P));
  continue; }
 if (!strcmp(kw,"objid")) {        char * K= parse_ident(P);
       tpl_replace(T,"$objid",K); continue; }

     if (!strcmp(kw,"class_name")) {  form_class_name= parse_ident(P);  continue; }

     if (!strcmp(kw,"title")) {        char *  K= parse_strlit(P);
        tpl_replace(T,"$title",K); continue; }

     if (!strcmp(kw,"pos_x")) {        int  K= parse_int(P);
        tpl_replace_i(T,"$pos_x", K);  continue; }

     if (!strcmp(kw,"pos_y")) {        int  K= parse_int(P);
        tpl_replace_i(T,"$pos_y", K);  continue; }

     if (!strcmp(kw,"default_width")) {        int  K= parse_int(P);
        tpl_replace_i(T,"$default_width", K);  continue; }

     if (!strcmp(kw,"default_height")) {        int  K= parse_int(P);
        tpl_replace_i(T,"$default_height", K);  continue; }

     if (!strcmp(kw,"close")) {  tpl_replace(T,"$close_code", parse_cpp(P)); continue; }


 if (!strcmp(kw, "signal")) {
   char  *id,*selector,*code;
   selector= parse_ident(P);
   id= parse_ident(P);
   code= parse_cpp(P);
   tpl_t *ST= tpl_new(
"\n"
" @form_members\n"
"  long $G_name(FXObject *object,FXSelector sel, void *arg);\n"
" @form_signal_mappings\n"
"  FXMAPFUNC($SELECTOR, $form_class::$ID, $form_class::$G_name),\n"
" @form_methods\n"
"  long $form_class::$G_name(FXObject *object,FXSelector sel, void *arg)\n"
"  {\n"
"    $code\n"
"  }\n"

   );
   tpl_replace(ST, "$ID", id);
   tpl_replace(ST, "$SELECTOR", selector);
   tpl_replace(ST, "$code", code);
   tpl_builtin(ST);
   tpl_relocations(T, ST);
   continue;
 }

  if (!strcmp(kw,"selector"))
  {
     tpl_t *trivial= tpl_new("\n@form_selector_ids\n$ID,\n");
     tpl_replace(trivial, "$ID", parse_ident(P));
     tpl_relocations(T, trivial);
     continue;
  }
  if (!strcmp(kw,"constructor"))
  {
     tpl_t *trivial= tpl_new("\n@form_constructor\n$code\n");
     tpl_replace(trivial, "$code", parse_cpp(P));
     tpl_relocations(T, trivial);
     continue;
  }
  if (!strcmp(kw,"members"))
  {
     tpl_t *trivial= tpl_new("\n@form_members\n$code\n");
     tpl_replace(trivial, "$code", parse_cpp(P));
     tpl_relocations(T, trivial);
     continue;
  }
  if (!strcmp(kw,"destructor"))
  {
     tpl_t *trivial= tpl_new("\n@form_destructor\n$code\n");
     tpl_replace(trivial, "$code", parse_cpp(P));
     tpl_relocations(T, trivial);
     continue;
  }

  { tpl_t *C;
    C= parse_sub_widget(P, kw);
    if (!C) p_error(P, 0, "unknown keyword '%s'.\n",kw);
    tpl_replace(C, "$container", "this");
    tpl_relocations(T, C);
    continue; }

       p_error(P,0, "unknown keyword %s.\n",kw);
  }
 
   if (form_class_name)
     tpl_replace(T, "$form_class", form_class_name);
   else
     tpl_replace(T, "$form_class", gen_symbol());
   tpl_builtin(T);

   return T;
}

#line 257 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 43 "/home/dodo/SFP/fxform-1.2/src/w_main_window.u"

#line 57 "/home/dodo/SFP/fxform-1.2/src/w_common.u"

static char *p_mainwindow_decorations(parser_t *P)
{
    char *dkw;
    static char *names[]= {
    "title", "minimize", "maximize",
    "close", "border", "shrinkable",
    "stretchable", "menu",0 };
    int decs[8];
    int i;
    for(i=0;i<8;i++) decs[i]= 0;
    parse_lcurly(P);
    while((dkw=parse_ident_or_rcurly(P)))
    {
         char *namepart; int R;
         if (!strncmp(dkw,"no_",3)) { namepart= dkw+3; R= 0; }
         else { namepart= dkw; R= 1; }
         for(i=0;names[i];i++)
           if (!strcmp(namepart,names[i])) { decs[i] = R; break; }
         if (!names[i]) {
            if (!strcmp(namepart,"resize"))
               decs[5]= decs[6]= R;
            else if (!strcmp(dkw,"all"))
               for(i=0;names[i];i++) decs[i]= 1;
            else if (!strcmp(dkw,"none"))
               for(i=0;names[i];i++) decs[i]= 0;
            else p_error(P,0,"unknown decoration %s.\n", dkw);
         }
    }

   char buf[1000];
   strcpy(buf," 0 ");
   for(i=0;names[i];i++)
     if (decs[i]) { 
      strcat(buf, " | DECOR_");
      strcat(buf, names[i]);
     }
   for(i=0;buf[i];i++) buf[i]= toupper(buf[i]);
   return strdup(buf);
}

#line 45 "/home/dodo/SFP/fxform-1.2/src/w_main_window.u"

#line 187 "/home/dodo/SFP/fxform-1.2/src/w_main_window.u"

