#line 149 "/home/dodo/SFP/fxform-1.2/src/w_radio.u"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "template.h"
#include "parse.h"


#line 250 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 12 "w_radio.c"


tpl_t *p_radio_group(parser_t *P)
{
 tpl_t *T= tpl_new(
"\n"
"@form_constructor\n"
"\n"
"  FYRadioGroup *$G_obj;\n"
"  $G_obj= $def($objid)($objid =) (FYRadioGroup*) malloc(sizeof(* $G_obj));\n"
"  $G_obj->target= & $objid$def(1)(_store);\n"
"  $G_obj->head= NULL;\n"
"\n"
"@form_members\n"
"  FYRadioGroup *$objid;\n"
"  int $objid$def(1)(_store);\n"
" // FIXME: I should find some prefix and not use the suffix _store..\n"
"\n"
"\n"
"@form_widget_declarations $def($objid) (gui_radio_group_t $objid;)\n"
"\n"
"@form_widget_export $def($objid)(\n"
" ifo->$objid.widget= ffo->$objid;\n"
" ifo->$objid.cls= &gui_radio_group_class;\n"
")\n"
"\n"
"\n"

  );
  static int class_emitted=0;
  if (!class_emitted) {
     class_emitted= 1;
     tpl_append(T, tpl_new(
"\n"
"@library_code\n"
"\n"
" typedef struct radio_item {\n"
"   struct radio_item *next;\n"
"   FXRadioButton *button;\n"
"   int value;\n"
" } radio_item_t;\n"
"\n"
" typedef struct {\n"
"   int *target;\n"
"   radio_item_t *head;\n"
" } FYRadioGroup;\n"
"\n"
"\n"
"@library_interface\n"
"typedef struct gui_radio_group gui_radio_group_t;\n"
"\n"
"typedef struct {\n"
"  void (*set_value)(struct gui_radio_group *, int);\n"
"  void (*get_value)(struct gui_radio_group*, int *);\n"
"} gui_radio_group_class_t;\n"
"\n"
"struct gui_radio_group\n"
"{\n"
"  gui_radio_group_class_t *cls;\n"
"  void *widget;\n"
"};\n"
"\n"
"@library_code\n"
"\n"
"static void set_value\n"
"  (FYRadioGroup *G, int V)\n"
"{\n"
"  radio_item_t *T;\n"
"  for(T=G->head;T;T=T->next)\n"
"    if (T->value==V) \n"
"     T->button->setCheck(TRUE);\n"
"    else T->button->setCheck(FALSE);\n"
"  G->target[0]= V;\n"
"}\n"
"\n"
"static void get_value\n"
"  (FYRadioGroup *G,int *R)\n"
"{\n"
"  *R= G->target[0];\n"
"}\n"
"\n"
"static void append(FYRadioGroup *G, FXRadioButton *B, int V)\n"
"{\n"
"  radio_item_t *T= (radio_item_t*) malloc(sizeof(*T));\n"
"  T->button= B;\n"
"  T->value= V;\n"
"  T->next= G->head;\n"
"  G->head= T;\n"
"}\n"
"\n"
"\n"
"static void radio_group_set_value\n"
"  (gui_radio_group_t *G, int V)\n"
"{\n"
"  set_value( (FYRadioGroup*) (G->widget), V);\n"
"}\n"
"\n"
"static void radio_group_get_value\n"
"  (gui_radio_group_t *G,int *R)\n"
"{\n"
"  get_value( (FYRadioGroup*) (G->widget), R);\n"
"}\n"
"\n"
"static gui_radio_group_class_t\n"
"gui_radio_group_class = {\n"
"  radio_group_set_value,\n"
"  radio_group_get_value,\n"
"};\n"
"\n"

       ));
  }
     parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 
   if (!strcmp(kw,"objid")) {        char * K= parse_ident(P);
       tpl_replace(T,"$objid",K); continue; }

      p_error(P,0, "unknown keyword %s.\n",kw);
  }
 
  tpl_builtin(T);
  return T;
}

tpl_t *p_radio_button(parser_t *P)
{
 tpl_t *T= tpl_new(
"\n"
"@form_constructor\n"
"\n"
"  FXRadioButton * $G_obj;\n"
"  $G_obj= new FXRadioButton($container, $dev($text)(\042\042), \n"
"               this, $G_selector, \n"
"        $dev($layout_x)(LAYOUT_LEFT) |\n"
"        $dev($layout_y)(LAYOUT_TOP) |\n"
"        $dev($layout_side)(LAYOUT_SIDE_TOP) |\n"
"        $dev($layout_fill_x)(0) |\n"
"        $dev($layout_fill_y)(0) |\n"
"        $dev($frame)(FRAME_NONE) |\n"
"        $dev($iconpos)(ICON_BEFORE_TEXT) |\n"
"        $dev($justify_x)(JUSTIFY_CENTER_X) |\n"
"        $dev($justify_y)(JUSTIFY_CENTER_Y) ,\n"
"\n"
"        0,0,0,0, // x,y,w,h\n"
"        $dev($pad_left)(DEFAULT_PAD),\n"
"        $dev($pad_right)(DEFAULT_PAD),\n"
"        $dev($pad_top)(DEFAULT_PAD),\n"
"        $dev($pad_bottom)(DEFAULT_PAD));\n"
"\n"
"    append( $group, $G_obj, $value );\n"
"\n"
"    $def($default)( $G_obj->setCheck(TRUE); $group$def(1)(_store)= $value; )\n"
"    $nef($default)( $G_obj->setCheck(FALSE); )\n"
"\n"
"\n"
"  $def($font_size $font_family)(\n"
"     FXFontDesc $G_font_desc;\n"
"     $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"  )\n"
"\n"
"  $def($font_size)(\n"
"     $G_font_desc.size= $font_size * 10;\n"
"  )\n"
"\n"
"  $def($font_family)(\n"
"     strcpy($G_font_desc.face, $font_family);\n"
"  )\n"
"\n"
"  $def($font_size $font_family)(\n"
"    $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"    $G_obj->setFont($G_font);\n"
"    @library_code  static FXFont *$G_font;\n"
"    @GUI_object_creation  // $G_font->create(); \n"
"    @form_constructor\n"
"  )\n"
"\n"
"\n"
"@form_signal_mappings\n"
"  FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector, $form_class::$G_click),\n"
"\n"
"@form_methods\n"
"\n"
"long $form_class::$G_click\n"
"  (FXObject *object,FXSelector sel, void *arg)\n"
"{\n"
"  set_value( $group, $value );\n"
"  $dev($click)(/* NOP */)\n"
"  // FIXME: put the on_click stuff here\n"
"  return 1;\n"
"}\n"
"\n"
"@form_members\n"
"  long $G_click(FXObject *object,FXSelector sel, void *arg);\n"
" \n"
"@form_selector_ids\n"
"  $G_selector,\n"
"\n"

  );
     parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 
   if (!strcmp(kw,"default")) {  tpl_replace(T,"$default","1");  continue; }

   if (!strcmp(kw,"text")) {        char *  K= parse_strlit(P);
        tpl_replace(T, "$text", K);  continue; }

   if (!strcmp(kw,"group")) {        char *  K= parse_ident(P);
        tpl_replace(T, "$group", K);  continue; }

   // FIXME: instead of kw_i, I shall make a call to kw
   // and then parse either an identifier or an integer
   // and accept any of them.
   if (!strcmp(kw,"value")) {        int  K= parse_int(P);
        tpl_replace_i(T, "$value", K);  continue; }

   if (!strcmp(kw,"click")) {  tpl_replace(T,"$click", parse_cpp(P));  continue; }

   if (!strcmp(kw,"pack_left")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_LEFT"); continue; }
if (!strcmp(kw,"pack_right")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_RIGHT"); continue; }
if (!strcmp(kw,"pack_top")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_TOP"); continue; }
if (!strcmp(kw,"pack_bottom")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_BOTTOM"); continue; }
if (!strcmp(kw,"stick_left")) { tpl_replace(T, "$layout_x", "LAYOUT_LEFT"); continue; }
if (!strcmp(kw,"stick_right")) { tpl_replace(T, "$layout_x", "LAYOUT_RIGHT"); continue; }
if (!strcmp(kw,"center_x")) { tpl_replace(T, "$layout_x", "LAYOUT_CENTER_X"); continue; }
if (!strcmp(kw,"stick_top")) { tpl_replace(T, "$layout_y", "LAYOUT_TOP"); continue; }
if (!strcmp(kw,"stick_bottom")) { tpl_replace(T, "$layout_y", "LAYOUT_BOTTOM"); continue; }
if (!strcmp(kw,"center_y")) { tpl_replace(T, "$layout_y", "LAYOUT_CENTER_Y"); continue; }
if (!strcmp(kw,"fill_x")) { tpl_replace(T, "$layout_fill_x", "LAYOUT_FILL_X"); continue; }
if (!strcmp(kw,"fill_y")) { tpl_replace(T, "$layout_fill_y", "LAYOUT_FILL_Y"); continue; }
 if (!strcmp(kw,"icon_before_text")) { tpl_replace(T, "$iconpos", "ICON_BEFORE_TEXT"); continue; }
if (!strcmp(kw,"icon_after_text")) { tpl_replace(T, "$iconpos", "ICON_AFTER_TEXT"); continue; }
if (!strcmp(kw,"icon_under_text")) { tpl_replace(T, "$iconpos", "ICON_UNDER_TEXT"); continue; }
if (!strcmp(kw,"icon_above_text")) { tpl_replace(T, "$iconpos", "ICON_ABOVE_TEXT"); continue; }

   if (!strcmp(kw,"frame_none")) { tpl_replace(T, "$frame", "FRAME_NONE"); continue; }
if (!strcmp(kw,"frame_sunken")) { tpl_replace(T, "$frame", "FRAME_SUNKEN"); continue; }
if (!strcmp(kw,"frame_raised")) { tpl_replace(T, "$frame", "FRAME_RAISED"); continue; }
if (!strcmp(kw,"frame_thick")) { tpl_replace(T, "$frame", "FRAME_THICK"); continue; }
if (!strcmp(kw,"frame_ridge")) { tpl_replace(T, "$frame", "FRAME_RIDGE"); continue; }
if (!strcmp(kw,"frame_line")) { tpl_replace(T, "$frame", "FRAME_LINE"); continue; }
 if (!strcmp(kw,"justify")) {    parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 if (!strcmp(kw,"center_x")) { tpl_replace(T, "$justify_x", "JUSTIFY_CENTER_X"); continue; }
if (!strcmp(kw,"left")) { tpl_replace(T, "$justify_x", "JUSTIFY_LEFT"); continue; }
if (!strcmp(kw,"right")) { tpl_replace(T, "$justify_x", "JUSTIFY_RIGHT"); continue; }
if (!strcmp(kw,"hz_apart")) { tpl_replace(T, "$justify_y", "JUSTIFY_HZ_APART"); continue; }
if (!strcmp(kw,"center_y")) { tpl_replace(T, "$justify_y", "JUSTIFY_CENTER_Y"); continue; }
if (!strcmp(kw,"top")) { tpl_replace(T, "$justify_y", "JUSTIFY_TOP"); continue; }
if (!strcmp(kw,"bottom")) { tpl_replace(T, "$justify_y", "JUSTIFY_BOTTOM"); continue; }
if (!strcmp(kw,"vt_apart")) { tpl_replace(T, "$justify_y", "JUSTIFY_VT_APART"); continue; }
    p_error(P,0, "unknown keyword %s.\n",kw);
  }
  continue; }

   if (!strcmp(kw,"pad_left")) {    tpl_replace_i(T, "$pad_left", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_right")) {    tpl_replace_i(T, "$pad_right", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_top")) {    tpl_replace_i(T, "$pad_top", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_bottom")) {    tpl_replace_i(T, "$pad_bottom", parse_int(P));
  continue; }

   if (!strcmp(kw,"font")) {    parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 if (!strcmp(kw,"size")) {        int sz= parse_int(P);
        tpl_replace_i(T, "$font_size", sz); continue; }
if (!strcmp(kw,"family")) {        char * fm= parse_strlit(P);
        tpl_replace(T, "$font_family", fm); continue; }
    p_error(P,0, "unknown keyword %s.\n",kw);
  }
  continue; }

      p_error(P,0, "unknown keyword %s.\n",kw);
  }
 
  tpl_builtin(T);
  return T;
}

#line 257 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 158 "/home/dodo/SFP/fxform-1.2/src/w_radio.u"

