#line 51 "/home/dodo/SFP/fxform-1.2/src/w_separator.u"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "template.h"
#include "parse.h"


#line 250 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 12 "w_separator.c"


tpl_t *p_separator(parser_t *P)
{
  tpl_t *T= tpl_new(
"\n"
"@form_constructor\n"
"\n"
"    new $def($ver)(FXVerticalSeparator)\n"
"        $def($hor)(FXHorizontalSeparator)\n"
"         ($container,\n"
"        $dev($layout_x)(LAYOUT_LEFT) |\n"
"        $dev($layout_y)(LAYOUT_TOP) |\n"
"        $dev($layout_side)(LAYOUT_SIDE_TOP) |\n"
"        $dev($layout_fill_x)($def($hor)(LAYOUT_FILL_X)$nef($hor)(0)) |\n"
"        $dev($layout_fill_y)($def($ver)(LAYOUT_FILL_Y)$nef($ver)(0)) |\n"
"        $dev($style)(SEPARATOR_GROOVE),\n"
"\n"
"        0,0,0,0, // x,y,w,h\n"
"        $dev($pad_left)(0),\n"
"        $dev($pad_right)(0),\n"
"        $dev($pad_top)(0),\n"
"        $dev($pad_bottom)(0));\n"
"\n"

  );
     parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 
    if (!strcmp(kw,"pack_left")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_LEFT"); continue; }
if (!strcmp(kw,"pack_right")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_RIGHT"); continue; }
if (!strcmp(kw,"pack_top")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_TOP"); continue; }
if (!strcmp(kw,"pack_bottom")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_BOTTOM"); continue; }
if (!strcmp(kw,"stick_left")) { tpl_replace(T, "$layout_x", "LAYOUT_LEFT"); continue; }
if (!strcmp(kw,"stick_right")) { tpl_replace(T, "$layout_x", "LAYOUT_RIGHT"); continue; }
if (!strcmp(kw,"center_x")) { tpl_replace(T, "$layout_x", "LAYOUT_CENTER_X"); continue; }
if (!strcmp(kw,"stick_top")) { tpl_replace(T, "$layout_y", "LAYOUT_TOP"); continue; }
if (!strcmp(kw,"stick_bottom")) { tpl_replace(T, "$layout_y", "LAYOUT_BOTTOM"); continue; }
if (!strcmp(kw,"center_y")) { tpl_replace(T, "$layout_y", "LAYOUT_CENTER_Y"); continue; }
if (!strcmp(kw,"fill_x")) { tpl_replace(T, "$layout_fill_x", "LAYOUT_FILL_X"); continue; }
if (!strcmp(kw,"fill_y")) { tpl_replace(T, "$layout_fill_y", "LAYOUT_FILL_Y"); continue; }

    if (!strcmp(kw,"pad_left")) {    tpl_replace_i(T, "$pad_left", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_right")) {    tpl_replace_i(T, "$pad_right", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_top")) {    tpl_replace_i(T, "$pad_top", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_bottom")) {    tpl_replace_i(T, "$pad_bottom", parse_int(P));
  continue; }

    if (!strcmp(kw,"vertical")) {  tpl_replace(T, "$ver", "1");  continue; }

    if (!strcmp(kw,"horizontal")) {  tpl_replace(T, "$hor", "1");  continue; }

    if (!strcmp(kw,"groove")) {  tpl_replace(T, "$style", "SEPARATOR_GROOVE");  continue; }

    if (!strcmp(kw,"ridge")) {  tpl_replace(T, "$style", "SEPARATOR_RIDGE");  continue; }

    if (!strcmp(kw,"line")) {  tpl_replace(T, "$style", "SEPARATOR_LINE");  continue; }

      p_error(P,0, "unknown keyword %s.\n",kw);
  }
 

  tpl_builtin(T);
  return T;
}

#line 257 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

