#line 116 "/home/dodo/SFP/fxform-1.2/src/w_tabbook.u"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "template.h"
#include "parse.h"

#line 250 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 11 "w_tabbook.c"


static tpl_t *p_tab(parser_t *P)
{
   tpl_t *child;
   tpl_t *T= tpl_new(
"\n"
"@form_constructor\n"
"  FXTabItem *$G_obj;\n"
"  $G_obj= new FXTabItem( $container,\n"
"                           $dev($title)(\042\042), NULL);\n"
"  // FIXME: do the fonts here\n"

   );
   int child_widget= 0;
      parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 
    if (!strcmp(kw,"title")) {        char *  K= parse_strlit(P);
        tpl_replace(T, "$title", K);  continue; }

    // FIXME: do the icon stuff here as well
    child= parse_sub_widget(P, kw);
    if (child) {
      if (child_widget) p_error(P,0, "only one child widget is "
                                 "permitted within a tab.\n");
      child_widget= 1;
      tpl_relocations(T, child);
      continue;
    }
       p_error(P,0, "unknown keyword %s.\n",kw);
  }
 
   tpl_builtin(T);
   return T;
}


tpl_t *p_tab_book(parser_t *P)
{
   tpl_t *T= tpl_new(
"\n"
"@form_constructor\n"
"  FXTabBook *$G_obj;\n"
"  $G_obj= $def($objid)($objid =) new FXTabBook($container,\n"
"           NULL, 0, // selector stuff\n"
"\n"
"        $dev($layout_x)(LAYOUT_LEFT) |\n"
"        $dev($layout_y)(LAYOUT_TOP) |\n"
"        $dev($layout_side)(LAYOUT_SIDE_TOP) |\n"
"        $dev($layout_fill_x)(0) |\n"
"        $dev($layout_fill_y)(0) |  0, // FIXME: do the tab-side stuff.\n"
"\n"
"        0,0,0,0, // xywh\n"
"        $dev($pad_left)(DEFAULT_SPACING),\n"
"        $dev($pad_right)(DEFAULT_SPACING),\n"
"        $dev($pad_top)(DEFAULT_SPACING),\n"
"        $dev($pad_bottom)(DEFAULT_SPACING));\n"
"\n"
"   <form_constructor>\n"
"\n"
"@form_members\n"
"  $def($objid)(FXTabBook *$objid;)\n"

   );
      parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 
     if (!strcmp(kw,"pack_left")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_LEFT"); continue; }
if (!strcmp(kw,"pack_right")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_RIGHT"); continue; }
if (!strcmp(kw,"pack_top")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_TOP"); continue; }
if (!strcmp(kw,"pack_bottom")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_BOTTOM"); continue; }
if (!strcmp(kw,"stick_left")) { tpl_replace(T, "$layout_x", "LAYOUT_LEFT"); continue; }
if (!strcmp(kw,"stick_right")) { tpl_replace(T, "$layout_x", "LAYOUT_RIGHT"); continue; }
if (!strcmp(kw,"center_x")) { tpl_replace(T, "$layout_x", "LAYOUT_CENTER_X"); continue; }
if (!strcmp(kw,"stick_top")) { tpl_replace(T, "$layout_y", "LAYOUT_TOP"); continue; }
if (!strcmp(kw,"stick_bottom")) { tpl_replace(T, "$layout_y", "LAYOUT_BOTTOM"); continue; }
if (!strcmp(kw,"center_y")) { tpl_replace(T, "$layout_y", "LAYOUT_CENTER_Y"); continue; }
if (!strcmp(kw,"fill_x")) { tpl_replace(T, "$layout_fill_x", "LAYOUT_FILL_X"); continue; }
if (!strcmp(kw,"fill_y")) { tpl_replace(T, "$layout_fill_y", "LAYOUT_FILL_Y"); continue; }

     if (!strcmp(kw,"objid")) {        char * K= parse_ident(P);
       tpl_replace(T,"$objid",K); continue; }

     if (!strcmp(kw,"tab")) {  
        tpl_t *child;
        child= p_tab(P);
        tpl_replace_var(child, "$container", "$G_obj");
        tpl_relocations(T, child);
        continue;
      continue; }

       p_error(P,0, "unknown keyword %s.\n",kw);
  }
 
   tpl_builtin(T);
   return T;
}

#line 257 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 124 "/home/dodo/SFP/fxform-1.2/src/w_tabbook.u"

