#line 187 "/home/dodo/SFP/fxform-1.2/src/w_text.u"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "template.h"
#include "parse.h"

#line 315 "/home/dodo/SFP/fxform-1.2/src/w_text.u"

static tpl_t *text_viewer_code()
{
  tpl_t *T= tpl_new(
#line 14 "w_text.c"
"\n"
"@form_constructor\n"
"\n"
"  FXText *$G_obj;\n"
"  $G_obj= $def($objid)($objid =) new FXText(\n"
"       $container, NULL,0, // target & selector\n"
"        $dev($layout_x)(LAYOUT_LEFT) |\n"
"        $dev($layout_y)(LAYOUT_TOP) |\n"
"        $dev($layout_side)(LAYOUT_SIDE_TOP) |\n"
"        $dev($layout_fill_x)(0) |\n"
"        $dev($layout_fill_y)(0) |\n"
"        $dev($wrap)(TEXT_WORDWRAP) |\n"
"        $dev($vertscroll)(VSCROLLER_ALWAYS) |\n"
"        TEXT_READONLY | \n"
"        $dev($frame)(0),\n"
"     0,0,0,0,  // x,y,w,h\n"
"             // FIXME: these are given as number constants in the\n"
"             // FXText constructor. Nothing symbolic like DEFAULT_PAD\n"
"             // etc. is used. So, I will do the same unwillingly.\n"
"     $dev($pad_left)(3),\n"
"     $dev($pad_right)(3),\n"
"     $dev($pad_top)(2),\n"
"     $dev($pad_bottom)(2));\n"
"\n"
"  $def($font_size $font_family)(\n"
"     FXFontDesc $G_font_desc;\n"
"     $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"  )\n"
"\n"
"  $def($font_size)(\n"
"     $G_font_desc.size= $font_size * 10;\n"
"  )\n"
"\n"
"  $def($font_family)(\n"
"     strcpy($G_font_desc.face, $font_family);\n"
"  )\n"
"\n"
"  $def($font_size $font_family)(\n"
"    $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"    $G_obj->setFont($G_font);\n"
"    @library_code  static FXFont *$G_font;\n"
"    @GUI_object_creation  // $G_font->create(); \n"
"    @form_constructor\n"
"  )\n"
"\n"
"\n"
"@form_members\n"
"\n"
"  $def($objid)(FXText *$objid;)\n"
"\n"
"@form_widget_declarations\n"
"\n"
" $def($objid)(gui_text_viewer_t $objid;)\n"
"\n"
"@form_widget_export\n"
"\n"
"$def($objid)(\n"
"  ifo->$objid.widget= ffo->$objid;\n"
"  ifo->$objid.cls= &gui_text_viewer_class;\n"
")\n"
"\n"

#line 322 "/home/dodo/SFP/fxform-1.2/src/w_text.u"
  );
  static int lib;
  if (!lib) 
   tpl_append(T, tpl_new(
#line 81 "w_text.c"
"\n"
"@library_interface\n"
"\n"
" typedef struct gui_text_viewer gui_text_viewer_t;\n"
"\n"
" typedef struct {\n"
"    void (*clear)(gui_text_viewer_t *);\n"
"    void (*set_text)(gui_text_viewer_t *,const char*);\n"
" } gui_text_viewer_class_t;\n"
"\n"
" struct gui_text_viewer {\n"
"    gui_text_viewer_class_t *cls;\n"
"    void *widget;\n"
" };\n"
"\n"
"\n"
"@library_code\n"
"\n"
"static void tv_set_text\n"
"  (gui_text_viewer_t *TV, const char *v)\n"
"{\n"
"  FXText *T= (FXText*) (TV->widget);\n"
"  T->setText(v);\n"
"}\n"
"\n"
"static void tv_clear\n"
"  (gui_text_viewer_t *TV)\n"
"{\n"
"  FXText *T= (FXText*) (TV->widget);\n"
"  T->removeText(0, T->getLength()); \n"
"}\n"
"\n"
" static gui_text_viewer_class_t gui_text_viewer_class= \n"
" {\n"
"   tv_clear,\n"
"   tv_set_text,\n"
" };\n"
"\n"

#line 329 "/home/dodo/SFP/fxform-1.2/src/w_text.u"
   ));
  lib= 1;
  return T;
}

#line 250 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 128 "w_text.c"


tpl_t *p_message_console(parser_t *P)
{
   tpl_t *T= tpl_new(
"\n"
"@form_constructor\n"
"\n"
"  FXText *$G_obj;\n"
"  $G_obj= $def($objid)($objid =) new FXText(\n"
"       $container, NULL,0, // target & selector\n"
"        $dev($layout_x)(LAYOUT_LEFT) |\n"
"        $dev($layout_y)(LAYOUT_TOP) |\n"
"        $dev($layout_side)(LAYOUT_SIDE_TOP) |\n"
"        $dev($layout_fill_x)(0) |\n"
"        $dev($layout_fill_y)(0) |\n"
"        $dev($wrap)(TEXT_FIXEDWRAP) |\n"
"        $dev($vertscroll)(VSCROLLER_ALWAYS) |\n"
"        TEXT_READONLY | TEXT_AUTOSCROLL |\n"
"        $dev($frame)(0),\n"
"     0,0,0,0,  // x,y,w,h\n"
"             // FIXME: these are given as number constants in the\n"
"             // FXText constructor. Nothing symbolic like DEFAULT_PAD\n"
"             // etc. is used. So, I will do the same unwillingly.\n"
"     $dev($pad_left)(3),\n"
"     $dev($pad_right)(3),\n"
"     $dev($pad_top)(2),\n"
"     $dev($pad_bottom)(2));\n"
"\n"
"  $def($font_size $font_family)(\n"
"     FXFontDesc $G_font_desc;\n"
"     $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"  )\n"
"\n"
"  $def($font_size)(\n"
"     $G_font_desc.size= $font_size * 10;\n"
"  )\n"
"\n"
"  $def($font_family)(\n"
"     strcpy($G_font_desc.face, $font_family);\n"
"  )\n"
"\n"
"  $def($font_size $font_family)(\n"
"    $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"    $G_obj->setFont($G_font);\n"
"    @library_code  static FXFont *$G_font;\n"
"    @GUI_object_creation  // $G_font->create(); \n"
"    @form_constructor\n"
"  )\n"
"\n"
"\n"
"@form_members\n"
"\n"
"  $def($objid)(FXText *$objid;)\n"
"\n"
"@form_widget_declarations\n"
"\n"
" $def($objid)(gui_message_console_t $objid;)\n"
"\n"
"@form_widget_export\n"
"\n"
"$def($objid)(\n"
"  ifo->$objid.widget= ffo->$objid;\n"
"  ifo->$objid.cls= &gui_message_console_class;\n"
")\n"
"\n"

  );
  static int class_emitted=0;
  if (!class_emitted) {
     class_emitted= 1;
     tpl_append(T, tpl_new(
"\n"
"@library_interface\n"
"\n"
" typedef struct gui_message_console gui_message_console_t;\n"
"\n"
" typedef struct {\n"
"    void (*print)(gui_message_console_t *,const char *,...);\n"
"    void (*clear)(gui_message_console_t *);\n"
"    void (*append)(gui_message_console_t *, const char *, size_t);\n"
" } gui_message_console_class_t;\n"
"\n"
" struct gui_message_console {\n"
"    gui_message_console_class_t *cls;\n"
"    void *widget;\n"
" };\n"
"\n"
"\n"
"@library_code\n"
"\n"
"\n"
"static void gui_message_console_print\n"
"   (gui_message_console_t *mc, const char * fmt,...)\n"
"{\n"
"   int size=200; char *message; int len; char *atmp;\n"
"   va_list ap;\n"
"   message= (char*) malloc(size);\n"
"   while(1) {\n"
"     va_start(ap,fmt);\n"
"     len= vsnprintf(message,size, fmt, ap);\n"
"     va_end(ap);\n"
"     if (len<0) size*= 2;\n"
"     else if (len<size) break;\n"
"     else size= len+2;\n"
"     message= (char*) realloc(atmp= message, size);\n"
"     if (!message) {\n"
"        free(atmp);\n"
"        message= (char*) fmt;\n"
"        break;\n"
"     }\n"
"  } \n"
"  FXText *W= (FXText*) mc->widget;\n"
"  W->appendText(message, strlen(message));\n"
"  if (message!=fmt) free(message);\n"
"   // argh, AUTOSCROLL doesn`t work yet. see\n"
"   // http://ruby.11.n6.nabble.com/TEXT-AUTOSCROLL-in-FXText-with-usage-of-FXDataTarget-td3510118.html\n"
"  W->makePositionVisible(W->getLength()-1);\n"
"}\n"
"\n"
"\n"
"static void gui_message_console_append\n"
"   (gui_message_console_t *mc, const char * str, size_t len)\n"
"{\n"
"  FXText *W= (FXText*) mc->widget;\n"
"  W->appendText(str, len);\n"
"   // argh, AUTOSCROLL doesn`t work yet. see\n"
"   // http://ruby.11.n6.nabble.com/TEXT-AUTOSCROLL-in-FXText-with-usage-of-FXDataTarget-td3510118.html\n"
"  W->makePositionVisible(W->getLength()-1);\n"
"}\n"
"\n"
"\n"
"\n"
"static void gui_message_console_clear(gui_message_console_t *mc)\n"
"{\n"
"  FXText *W= (FXText*) mc->widget;\n"
"  W->removeText(0, W->getLength()); \n"
"}\n"
"\n"
"static gui_message_console_class_t \n"
"  gui_message_console_class= \n"
"{\n"
"  gui_message_console_print,\n"
"  gui_message_console_clear,\n"
"  gui_message_console_append,\n"
"};\n"
"\n"

       ));
  }
     parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 
    if (!strcmp(kw,"text")) {        char *  K= parse_strlit(P);
        tpl_replace(T,"$text", K);  continue; }

    if (!strcmp(kw,"objid")) {        char * K= parse_ident(P);
       tpl_replace(T,"$objid",K); continue; }

    if (!strcmp(kw,"pack_left")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_LEFT"); continue; }
if (!strcmp(kw,"pack_right")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_RIGHT"); continue; }
if (!strcmp(kw,"pack_top")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_TOP"); continue; }
if (!strcmp(kw,"pack_bottom")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_BOTTOM"); continue; }
if (!strcmp(kw,"stick_left")) { tpl_replace(T, "$layout_x", "LAYOUT_LEFT"); continue; }
if (!strcmp(kw,"stick_right")) { tpl_replace(T, "$layout_x", "LAYOUT_RIGHT"); continue; }
if (!strcmp(kw,"center_x")) { tpl_replace(T, "$layout_x", "LAYOUT_CENTER_X"); continue; }
if (!strcmp(kw,"stick_top")) { tpl_replace(T, "$layout_y", "LAYOUT_TOP"); continue; }
if (!strcmp(kw,"stick_bottom")) { tpl_replace(T, "$layout_y", "LAYOUT_BOTTOM"); continue; }
if (!strcmp(kw,"center_y")) { tpl_replace(T, "$layout_y", "LAYOUT_CENTER_Y"); continue; }
if (!strcmp(kw,"fill_x")) { tpl_replace(T, "$layout_fill_x", "LAYOUT_FILL_X"); continue; }
if (!strcmp(kw,"fill_y")) { tpl_replace(T, "$layout_fill_y", "LAYOUT_FILL_Y"); continue; }

    if (!strcmp(kw,"frame_none")) { tpl_replace(T, "$frame", "FRAME_NONE"); continue; }
if (!strcmp(kw,"frame_sunken")) { tpl_replace(T, "$frame", "FRAME_SUNKEN"); continue; }
if (!strcmp(kw,"frame_raised")) { tpl_replace(T, "$frame", "FRAME_RAISED"); continue; }
if (!strcmp(kw,"frame_thick")) { tpl_replace(T, "$frame", "FRAME_THICK"); continue; }
if (!strcmp(kw,"frame_ridge")) { tpl_replace(T, "$frame", "FRAME_RIDGE"); continue; }
if (!strcmp(kw,"frame_line")) { tpl_replace(T, "$frame", "FRAME_LINE"); continue; }
 if (!strcmp(kw,"justify")) {    parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 if (!strcmp(kw,"center_x")) { tpl_replace(T, "$justify_x", "JUSTIFY_CENTER_X"); continue; }
if (!strcmp(kw,"left")) { tpl_replace(T, "$justify_x", "JUSTIFY_LEFT"); continue; }
if (!strcmp(kw,"right")) { tpl_replace(T, "$justify_x", "JUSTIFY_RIGHT"); continue; }
if (!strcmp(kw,"hz_apart")) { tpl_replace(T, "$justify_y", "JUSTIFY_HZ_APART"); continue; }
if (!strcmp(kw,"center_y")) { tpl_replace(T, "$justify_y", "JUSTIFY_CENTER_Y"); continue; }
if (!strcmp(kw,"top")) { tpl_replace(T, "$justify_y", "JUSTIFY_TOP"); continue; }
if (!strcmp(kw,"bottom")) { tpl_replace(T, "$justify_y", "JUSTIFY_BOTTOM"); continue; }
if (!strcmp(kw,"vt_apart")) { tpl_replace(T, "$justify_y", "JUSTIFY_VT_APART"); continue; }
    p_error(P,0, "unknown keyword %s.\n",kw);
  }
  continue; }

    if (!strcmp(kw,"pad_left")) {    tpl_replace_i(T, "$pad_left", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_right")) {    tpl_replace_i(T, "$pad_right", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_top")) {    tpl_replace_i(T, "$pad_top", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_bottom")) {    tpl_replace_i(T, "$pad_bottom", parse_int(P));
  continue; }

    if (!strcmp(kw,"font")) {    parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 if (!strcmp(kw,"size")) {        int sz= parse_int(P);
        tpl_replace_i(T, "$font_size", sz); continue; }
if (!strcmp(kw,"family")) {        char * fm= parse_strlit(P);
        tpl_replace(T, "$font_family", fm); continue; }
    p_error(P,0, "unknown keyword %s.\n",kw);
  }
  continue; }

    if (!strcmp(kw,"word_wrap")) {  tpl_replace(T,"$wrap", "TEXT_WORDWRAP");  continue; }

    if (!strcmp(kw,"no_wrap")) {  tpl_replace(T,"$wrap", "0");  continue; }

    if (!strcmp(kw,"no_vertical_scroller")) {  tpl_replace(T,"$vertscroll","0");  continue; }

      p_error(P,0, "unknown keyword %s.\n",kw);
  }
 

  tpl_builtin(T);
  return T;
}


tpl_t *p_text_viewer(parser_t *P)
{
  tpl_t *T= text_viewer_code();
     parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 
    if (!strcmp(kw,"text")) {        char *  K= parse_strlit(P);
        tpl_replace(T,"$text", K);  continue; }

    if (!strcmp(kw,"objid")) {        char * K= parse_ident(P);
       tpl_replace(T,"$objid",K); continue; }

    if (!strcmp(kw,"pack_left")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_LEFT"); continue; }
if (!strcmp(kw,"pack_right")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_RIGHT"); continue; }
if (!strcmp(kw,"pack_top")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_TOP"); continue; }
if (!strcmp(kw,"pack_bottom")) { tpl_replace(T, "$layout_side", "LAYOUT_SIDE_BOTTOM"); continue; }
if (!strcmp(kw,"stick_left")) { tpl_replace(T, "$layout_x", "LAYOUT_LEFT"); continue; }
if (!strcmp(kw,"stick_right")) { tpl_replace(T, "$layout_x", "LAYOUT_RIGHT"); continue; }
if (!strcmp(kw,"center_x")) { tpl_replace(T, "$layout_x", "LAYOUT_CENTER_X"); continue; }
if (!strcmp(kw,"stick_top")) { tpl_replace(T, "$layout_y", "LAYOUT_TOP"); continue; }
if (!strcmp(kw,"stick_bottom")) { tpl_replace(T, "$layout_y", "LAYOUT_BOTTOM"); continue; }
if (!strcmp(kw,"center_y")) { tpl_replace(T, "$layout_y", "LAYOUT_CENTER_Y"); continue; }
if (!strcmp(kw,"fill_x")) { tpl_replace(T, "$layout_fill_x", "LAYOUT_FILL_X"); continue; }
if (!strcmp(kw,"fill_y")) { tpl_replace(T, "$layout_fill_y", "LAYOUT_FILL_Y"); continue; }

    if (!strcmp(kw,"frame_none")) { tpl_replace(T, "$frame", "FRAME_NONE"); continue; }
if (!strcmp(kw,"frame_sunken")) { tpl_replace(T, "$frame", "FRAME_SUNKEN"); continue; }
if (!strcmp(kw,"frame_raised")) { tpl_replace(T, "$frame", "FRAME_RAISED"); continue; }
if (!strcmp(kw,"frame_thick")) { tpl_replace(T, "$frame", "FRAME_THICK"); continue; }
if (!strcmp(kw,"frame_ridge")) { tpl_replace(T, "$frame", "FRAME_RIDGE"); continue; }
if (!strcmp(kw,"frame_line")) { tpl_replace(T, "$frame", "FRAME_LINE"); continue; }
 if (!strcmp(kw,"justify")) {    parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 if (!strcmp(kw,"center_x")) { tpl_replace(T, "$justify_x", "JUSTIFY_CENTER_X"); continue; }
if (!strcmp(kw,"left")) { tpl_replace(T, "$justify_x", "JUSTIFY_LEFT"); continue; }
if (!strcmp(kw,"right")) { tpl_replace(T, "$justify_x", "JUSTIFY_RIGHT"); continue; }
if (!strcmp(kw,"hz_apart")) { tpl_replace(T, "$justify_y", "JUSTIFY_HZ_APART"); continue; }
if (!strcmp(kw,"center_y")) { tpl_replace(T, "$justify_y", "JUSTIFY_CENTER_Y"); continue; }
if (!strcmp(kw,"top")) { tpl_replace(T, "$justify_y", "JUSTIFY_TOP"); continue; }
if (!strcmp(kw,"bottom")) { tpl_replace(T, "$justify_y", "JUSTIFY_BOTTOM"); continue; }
if (!strcmp(kw,"vt_apart")) { tpl_replace(T, "$justify_y", "JUSTIFY_VT_APART"); continue; }
    p_error(P,0, "unknown keyword %s.\n",kw);
  }
  continue; }

    if (!strcmp(kw,"pad_left")) {    tpl_replace_i(T, "$pad_left", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_right")) {    tpl_replace_i(T, "$pad_right", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_top")) {    tpl_replace_i(T, "$pad_top", parse_int(P));
  continue; }
if (!strcmp(kw,"pad_bottom")) {    tpl_replace_i(T, "$pad_bottom", parse_int(P));
  continue; }

    if (!strcmp(kw,"font")) {    parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 if (!strcmp(kw,"size")) {        int sz= parse_int(P);
        tpl_replace_i(T, "$font_size", sz); continue; }
if (!strcmp(kw,"family")) {        char * fm= parse_strlit(P);
        tpl_replace(T, "$font_family", fm); continue; }
    p_error(P,0, "unknown keyword %s.\n",kw);
  }
  continue; }

    if (!strcmp(kw,"fixed_wrap")) {  tpl_replace(T,"$wrap", "TEXT_FIXEDWRAP");  continue; }

    if (!strcmp(kw,"no_wrap")) {  tpl_replace(T,"$wrap", "0");  continue; }

    if (!strcmp(kw,"no_vertical_scroller")) {  tpl_replace(T,"$vertscroll","0");  continue; }

      p_error(P,0, "unknown keyword %s.\n",kw);
  }
 

  tpl_builtin(T);
  return T;
}

#line 257 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 196 "/home/dodo/SFP/fxform-1.2/src/w_text.u"

