

typedef struct tpl tpl_t;


tpl_t *tpl_new(char *str);
void tpl_print(tpl_t *T);
char *tpl_to_str(tpl_t *T);
void tpl_append(tpl_t *dest, tpl_t *src);
void tpl_replace(tpl_t *TPL,char *name, char *value);
void tpl_replace_i(tpl_t *T, char *name, int v);
void tpl_free(tpl_t *T);
void tpl_replace_vars(tpl_t *T,char *repl, ...);
void tpl_builtin(tpl_t *TPL);
void tpl_relocations(tpl_t *dest,tpl_t *src);
void tpl_relocations_known_only(tpl_t *dest, tpl_t *src);
